package com.intrinsyc.cdo;

import com.linar.jintegra.*;
/**
 * Proxy for COM Interface 'AddressEntries'. Generated 09-Jan-08 12:10:54 PM
 * from 'C:\Program Files\Common Files\System\MSMAPI\1033\CDO.DLL'<P>
 * Generated using com2java Version 2.8 (c) 2008 Intrinsyc Software International, Inc.  All rights reserved.
 * See  <A HREF="http://j-integra.intrinsyc.com/">http://j-integra.intrinsyc.com/</A><P>
 * Description: '<B>AddrEntries collection</B>'
 *
 * Generator Options:
 *   AwtForOcxs = False
 *   PromptForTypeLibraries = False
 *   RetryOnReject = False
 *   IDispatchOnly = False
 *   GenBeanInfo = False
 *   LowerCaseMemberNames = True
 *   TreatInStarAsIn = False
 *   ArraysAsObjects = False
 *   OmitRestrictedMethods = False
 *   ClashPrefix = zz_
 *   ImplementConflictingInterfaces = False
 *   DontRenameSameMethods = False
 *   RenameConflictingInterfaceMethods = False
 *   ReuseMethods = False
 *
 * Command Line Only Options:
 *   MakeClsidsPublic = False
 *   DontOverwrite = False
 */
public class AddressEntriesProxy extends com.linar.jintegra.Dispatch implements com.intrinsyc.cdo.AddressEntries, java.io.Serializable {

  protected String getJintegraVersion() { return "2.8"; }

  static { com.intrinsyc.cdo.JIntegraInit.init(); }

  public static final Class targetClass = AddressEntries.class;

  public AddressEntriesProxy(String CLSID, String host, AuthInfo authInfo) throws java.net.UnknownHostException, java.io.IOException{
    super(CLSID, AddressEntries.IID, host, authInfo);
  }

  /** For internal use only */
  public AddressEntriesProxy() {}

  public AddressEntriesProxy(Object obj) throws java.io.IOException {
    super(obj, AddressEntries.IID);
  }

  protected AddressEntriesProxy(Object obj, String iid) throws java.io.IOException {
    super(obj, iid);
  }

  protected AddressEntriesProxy(String CLSID, String iid, String host, AuthInfo authInfo) throws java.io.IOException {
    super(CLSID, iid, host, authInfo);
  }

  public void addListener(String iidStr, Object theListener, Object theSource) throws java.io.IOException {
    super.addListener(iidStr, theListener, theSource);
  }

  public void removeListener(String iidStr, Object theListener) throws java.io.IOException {
    super.removeListener(iidStr, theListener);
  }

  /**
   * getPropertyByName. Get the value of a property dynamically at run-time, based on its name
   *
   * @return    The value of the property.
   * @param     name The name of the property to get.
   * @exception java.lang.NoSuchFieldException If the property does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPropertyByName(String name) throws NoSuchFieldException, java.io.IOException, com.linar.jintegra.AutomationException {
    com.linar.jintegra.Variant parameters[] = {};
    return super.invoke(name, super.getDispatchIdOfName(name), 2, parameters).getVARIANT();
  }

  /**
   * getPropertyByName. Get the value of a property dynamically at run-time, based on its name and a parameter value
   *
   * @return    The value of the property.
   * @param     name The name of the property to get.
   * @param     rhs Parameter used when getting the property.
   * @exception java.lang.NoSuchFieldException If the property does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPropertyByName(String name, Object rhs) throws NoSuchFieldException, java.io.IOException, com.linar.jintegra.AutomationException {
    com.linar.jintegra.Variant parameters[] = {rhs == null ? new Variant("rhs", 10, 0x80020004L) : new Variant("rhs", 12, rhs)};
    return super.invoke(name, super.getDispatchIdOfName(name), 2, parameters).getVARIANT();
  }

  /**
   * invokeMethodByName. Invoke a method dynamically at run-time
   *
   * @return    The value returned by the method (null if none).
   * @param     name The name of the method to be invoked
   * @param     parameters One element for each parameter.  Use primitive type wrappers
   *            to pass primitive types (eg Integer to pass an int).
   * @exception java.lang.NoSuchMethodException If the method does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object invokeMethodByName(String name, Object[] parameters) throws NoSuchMethodException, java.io.IOException, com.linar.jintegra.AutomationException {
    com.linar.jintegra.Variant variantParameters[] = new com.linar.jintegra.Variant[parameters.length];
    for(int i = 0; i < parameters.length; i++) {
      variantParameters[i] = parameters[i] == null ? new Variant("p" + i, 10, 0x80020004L) :
	                                                   new Variant("p" + i, 12, parameters[i]);
    }
    try {
      return super.invoke(name, super.getDispatchIdOfName(name), 1, variantParameters).getVARIANT();
    } catch(NoSuchFieldException nsfe) {
      throw new NoSuchMethodException("There is no method called " + name);
    }
  }

  /**
   * invokeMethodByName. Invoke a method dynamically at run-time
   *
   * @return    The value returned by the method (null if none).
   * @param     name The name of the method to be invoked
   * @exception java.lang.NoSuchMethodException If the method does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object invokeMethodByName(String name) throws NoSuchMethodException, java.io.IOException, com.linar.jintegra.AutomationException {
      return invokeMethodByName(name, new Object[]{});
  }

  /**
   * getApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getApplication  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getApplication", 20, 2, parameters).getVARIANT();
  }

  /**
   * setApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setApplication  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setApplication", 20, 4, parameters);
    return;
  }

  /**
   * getParent. The Parent property returns the parent of the object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getParent  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getParent", 25, 2, parameters).getVARIANT();
  }

  /**
   * setParent. The Parent property returns the parent of the object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setParent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setParent", 25, 4, parameters);
    return;
  }

  /**
   * getSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSession  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSession", 34, 2, parameters).getVARIANT();
  }

  /**
   * setSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSession  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSession", 34, 4, parameters);
    return;
  }

  /**
   * zz_getClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object zz_getClass  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("zz_getClass", 6, 2, parameters).getVARIANT();
  }

  /**
   * setClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setClass  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setClass", 6, 4, parameters);
    return;
  }

  /**
   * getRawTable. 
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getRawTable  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getRawTable", 80, 2, parameters).getVARIANT();
  }

  /**
   * setRawTable. 
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setRawTable  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setRawTable", 80, 4, parameters);
    return;
  }

  /**
   * getCount. The Count property returns the number of AddressEntry objects in the collection, or a very large number if the exact count is not available.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getCount  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getCount", 9, 2, parameters).getVARIANT();
  }

  /**
   * setCount. The Count property returns the number of AddressEntry objects in the collection, or a very large number if the exact count is not available.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setCount  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setCount", 9, 4, parameters);
    return;
  }

  /**
   * getFilter. The Filter property returns an AddressEntryFilter object for the AddressEntries collection.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFilter  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getFilter", 61, 2, parameters).getVARIANT();
  }

  /**
   * setFilter. The Filter property returns an AddressEntryFilter object for the AddressEntries collection.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setFilter  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setFilter", 61, 4, parameters);
    return;
  }

  /**
   * getItem. The Item property returns a single AddressEntry object from the AddressEntries collection.
   *
   * @param     index A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getItem  (
              Object index) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {index == null ? new Variant("index", 0, 0x80020004L) : new Variant("index", 12, index),};
    return invoke("getItem", 21, 2, parameters).getVARIANT();
  }

  /**
   * delete. The Delete method deletes all the address entries in the AddressEntries collection.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object delete  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("delete", 106, 1, parameters).getVARIANT();
  }

  /**
   * add. The Add method creates and returns a new AddressEntry object in the AddressEntries collection.
   *
   * @param     emailtype A Variant (in)
   * @param     name A Variant (in, optional, pass null if not required)
   * @param     address A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object add  (
              Object emailtype,
              Object name,
              Object address) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {emailtype == null ? new Variant("emailtype", 0, 0x80020004L) : new Variant("emailtype", 12, emailtype),
                                         name == null ? new Variant("name", 10, 0x80020004L) : new Variant("name", 12, name),
                                         address == null ? new Variant("address", 10, 0x80020004L) : new Variant("address", 12, address),};
    return invoke("add", 100, 1, parameters).getVARIANT();
  }

  /**
   * getFirst. The GetFirst method returns the first AddressEntry object in the AddressEntries collection. It returns Nothing if no first object exists.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFirst  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getFirst", 109, 1, parameters).getVARIANT();
  }

  /**
   * getNext. The GetNext method returns the next AddressEntry object in the AddressEntries collection. It returns Nothing if no next object exists, for example if already positioned at the end of the collection.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getNext  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getNext", 111, 1, parameters).getVARIANT();
  }

  /**
   * getLast. The GetLast method returns the last AddressEntry object in the AddressEntries collection. It returns Nothing if no last object exists.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getLast  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getLast", 110, 1, parameters).getVARIANT();
  }

  /**
   * getPrevious. The GetPrevious method returns the previous AddressEntry object in the AddressEntries collection. It returns Nothing if no previous object exists, for example if already positioned at the beginning of the collection.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPrevious  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getPrevious", 112, 1, parameters).getVARIANT();
  }

  /**
   * sort. The Sort method sorts the address entries in the collection on the specified property according to the specified sort order.
   *
   * @param     sortOrder A Variant (in, optional, pass null if not required)
   * @param     propID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object sort  (
              Object sortOrder,
              Object propID) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {sortOrder == null ? new Variant("sortOrder", 10, 0x80020004L) : new Variant("sortOrder", 12, sortOrder),
                                         propID == null ? new Variant("propID", 10, 0x80020004L) : new Variant("propID", 12, propID),};
    return invoke("sort", 134, 1, parameters).getVARIANT();
  }

  /** Dummy reference from interface to proxy to make sure proxy gets compiled */
  static final int xxDummy = 0;

  static {
    com.linar.jintegra.InterfaceDesc.add("3fa7deb1-6438-101b-acc1-00aa00423326", com.intrinsyc.cdo.AddressEntriesProxy.class, null, 0, null );
  }
}
