package com.intrinsyc.cdo;

/**
 * COM Interface 'AppointmentItem'. Generated 09-Jan-08 12:10:54 PM
 * from 'C:\Program Files\Common Files\System\MSMAPI\1033\CDO.DLL'<P>
 * Generated using com2java Version 2.8 (c) 2008 Intrinsyc Software International, Inc.  All rights reserved.
 * See  <A HREF="http://j-integra.intrinsyc.com/">http://j-integra.intrinsyc.com/</A><P>
 * Description: '<B>AppointmentItem object</B>'
 *
 * Generator Options:
 *   AwtForOcxs = False
 *   PromptForTypeLibraries = False
 *   RetryOnReject = False
 *   IDispatchOnly = False
 *   GenBeanInfo = False
 *   LowerCaseMemberNames = True
 *   TreatInStarAsIn = False
 *   ArraysAsObjects = False
 *   OmitRestrictedMethods = False
 *   ClashPrefix = zz_
 *   ImplementConflictingInterfaces = False
 *   DontRenameSameMethods = False
 *   RenameConflictingInterfaceMethods = False
 *   ReuseMethods = False
 *
 * Command Line Only Options:
 *   MakeClsidsPublic = False
 *   DontOverwrite = False
 */
public interface AppointmentItem extends java.io.Serializable {
  /**
   * getApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getApplication  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setApplication  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getParent. The Parent property returns the parent of the object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getParent  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setParent. The Parent property returns the parent of the object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setParent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSession  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSession  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * zz_getClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object zz_getClass  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setClass  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getMAPIOBJECT. 
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMAPIOBJECT  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setMAPIOBJECT. 
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setMAPIOBJECT  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getFolderID. The FolderID property returns the unique identifier of the folder in which the message resides.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFolderID  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setFolderID. The FolderID property returns the unique identifier of the folder in which the message resides.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setFolderID  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getStoreID. The StoreID property represents the unique identifier for the message store that contains the message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getStoreID  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setStoreID. The StoreID property represents the unique identifier for the message store that contains the message.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setStoreID  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getID. The ID property returns the unique identifier of the Message object as a string.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getID  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setID. The ID property returns the unique identifier of the Message object as a string.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setID  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getType. The Type property returns or sets the message class for the message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getType  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setType. The Type property returns or sets the message class for the message.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setType  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSize. The Size property returns the approximate size in bytes of the message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSize  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSize. The Size property returns the approximate size in bytes of the message.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSize  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getImportance. The Importance property returns or sets the importance of the message as ActMsgNormal (the default), ActMsgLow, or ActMsgHigh.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getImportance  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setImportance. The Importance property returns or sets the importance of the message as ActMsgNormal (the default), ActMsgLow, or ActMsgHigh.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setImportance  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSubject. The Subject property returns or sets the subject of the message as a string.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSubject  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSubject. The Subject property returns or sets the subject of the message as a string.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSubject  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSender. The Sender property returns or sets the sender of a message as an AddressEntry object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSender  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSender. The Sender property returns or sets the sender of a message as an AddressEntry object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSender  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getTimeSent. The TimeSent property sets or returns the date and time the message was sent as a vbDate variant data type.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getTimeSent  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setTimeSent. The TimeSent property sets or returns the date and time the message was sent as a vbDate variant data type.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setTimeSent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getTimeReceived. The TimeReceived property sets or returns the date and time the message was received as a vbDate variant data type.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getTimeReceived  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setTimeReceived. The TimeReceived property sets or returns the date and time the message was received as a vbDate variant data type.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setTimeReceived  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getText. The Text property returns or sets the text of the message as a string.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getText  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setText. The Text property returns or sets the text of the message as a string.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setText  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSent. The Sent property is True if the message has been sent through the messaging system.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSent  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSent. The Sent property is True if the message has been sent through the messaging system.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSubmitted. The Submitted property is True when the message has been submitted.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSubmitted  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSubmitted. The Submitted property is True when the message has been submitted.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSubmitted  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getUnread. The Unread property is True if the message has not been read by the current user.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getUnread  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setUnread. The Unread property is True if the message has not been read by the current user.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setUnread  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSigned. The Signed property is True if the message has been tagged with a digital signature.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSigned  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSigned. The Signed property is True if the message has been tagged with a digital signature.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSigned  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getEncrypted. The Encrypted property is True if the message has been encrypted.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getEncrypted  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setEncrypted. The Encrypted property is True if the message has been encrypted.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setEncrypted  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getReadReceipt. The ReadReceipt property is True if a read-receipt notification message is requested.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getReadReceipt  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setReadReceipt. The ReadReceipt property is True if a read-receipt notification message is requested.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setReadReceipt  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getDeliveryReceipt. The DeliveryReceipt property is True if a delivery-receipt notification message is requested.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getDeliveryReceipt  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setDeliveryReceipt. The DeliveryReceipt property is True if a delivery-receipt notification message is requested.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setDeliveryReceipt  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getConversation. The Conversation property is obsolete. It has been replaced by the ConversationIndex and ConversationTopic properties.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getConversation  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setConversation. The Conversation property is obsolete. It has been replaced by the ConversationIndex and ConversationTopic properties.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setConversation  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getConversationIndex. The ConversationIndex property specifies the index to the conversation thread of the message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getConversationIndex  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setConversationIndex. The ConversationIndex property specifies the index to the conversation thread of the message.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setConversationIndex  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getConversationTopic. The ConversationTopic property specifies the subject of the conversation thread of the message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getConversationTopic  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setConversationTopic. The ConversationTopic property specifies the subject of the conversation thread of the message.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setConversationTopic  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getFields. The Fields property returns a single Field object or a Fields collection object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFields  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setFields. The Fields property returns a single Field object or a Fields collection object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setFields  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getRecipients. The Recipients property returns a single Recipient object or a Recipients collection object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getRecipients  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setRecipients. The Recipients property returns a single Recipient object or a Recipients collection object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setRecipients  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getAttachments. The Attachments property returns a single Attachment object or an Attachments collection object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAttachments  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setAttachments. The Attachments property returns a single Attachment object or an Attachments collection object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setAttachments  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getCategories. The Categories property specifies the categories assigned to the message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getCategories  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setCategories. The Categories property specifies the categories assigned to the message.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setCategories  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getTimeCreated. The TimeCreated property specifies the date/time the message was first saved.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getTimeCreated  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setTimeCreated. The TimeCreated property specifies the date/time the message was first saved.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setTimeCreated  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getTimeExpired. The TimeExpired property specifies the date/time the message will expire.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getTimeExpired  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setTimeExpired. The TimeExpired property specifies the date/time the message will expire.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setTimeExpired  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSensitivity. The Sensitivity property specifies the sensitivity of the message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSensitivity  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSensitivity. The Sensitivity property specifies the sensitivity of the message.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSensitivity  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getTimeLastModified. The TimeLastModified property specifies the date/time the message was most recently saved.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getTimeLastModified  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setTimeLastModified. The TimeLastModified property specifies the date/time the message was most recently saved.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setTimeLastModified  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getAllDayEvent. The AllDayEvent property indicates whether this appointment is an all-day event.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAllDayEvent  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setAllDayEvent. The AllDayEvent property indicates whether this appointment is an all-day event.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setAllDayEvent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getBusyStatus. The BusyStatus property returns or sets the busy status of this messaging user for this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getBusyStatus  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setBusyStatus. The BusyStatus property returns or sets the busy status of this messaging user for this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setBusyStatus  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getDuration. The Duration property returns the duration of this appointment in minutes.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getDuration  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setDuration. The Duration property returns the duration of this appointment in minutes.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setDuration  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getEndTime. The EndTime property returns or sets the ending date/time of this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getEndTime  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setEndTime. The EndTime property returns or sets the ending date/time of this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setEndTime  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getStartTime. The StartTime property returns or sets the starting date/time of this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getStartTime  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setStartTime. The StartTime property returns or sets the starting date/time of this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setStartTime  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getIsRecurring. The IsRecurring property indicates whether this appointment is specified as recurring.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getIsRecurring  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setIsRecurring. The IsRecurring property indicates whether this appointment is specified as recurring.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setIsRecurring  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getLocation. The Location property returns or sets the location of this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getLocation  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setLocation. The Location property returns or sets the location of this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setLocation  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getMeetingStatus. The MeetingStatus property returns or sets the overall meeting status of this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMeetingStatus  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setMeetingStatus. The MeetingStatus property returns or sets the overall meeting status of this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setMeetingStatus  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getOrganizer. The Organizer property returns the messaging user that initiated this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOrganizer  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setOrganizer. The Organizer property returns the messaging user that initiated this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOrganizer  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getReminderMinutesBeforeStart. The ReminderMinutesBeforeStart property indicates how many minutes before the start of this appointment a reminder should be issued.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getReminderMinutesBeforeStart  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setReminderMinutesBeforeStart. The ReminderMinutesBeforeStart property indicates how many minutes before the start of this appointment a reminder should be issued.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setReminderMinutesBeforeStart  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getReminderSet. The ReminderSet property indicates whether this messaging user is to be reminded of this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getReminderSet  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setReminderSet. The ReminderSet property indicates whether this messaging user is to be reminded of this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setReminderSet  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getReplyTime. The ReplyTime property returns or sets the date/time by which action on this appointment is expected.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getReplyTime  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setReplyTime. The ReplyTime property returns or sets the date/time by which action on this appointment is expected.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setReplyTime  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getResponseRequested. The ResponseRequested property indicates whether a response is requested for this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getResponseRequested  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setResponseRequested. The ResponseRequested property indicates whether a response is requested for this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setResponseRequested  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getMeetingResponseStatus. The MeetingResponseStatus property returns or sets the overall status of this appointment for this messaging user.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMeetingResponseStatus  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setMeetingResponseStatus. The MeetingResponseStatus property returns or sets the overall status of this appointment for this messaging user.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setMeetingResponseStatus  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * isSameAs. The IsSameAs method returns True if the Message object is the same as the Message object being compared against.
   *
   * @param     object A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object isSameAs  (
              Object object) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * delete. The Delete method deletes the Message object.
   *
   * @param     deletedItems A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object delete  (
              Object deletedItems) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * update. The Update method saves the message in the messaging system.
   *
   * @param     makePermanent A Variant (in, optional, pass null if not required)
   * @param     refreshObject A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object update  (
              Object makePermanent,
              Object refreshObject) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * options. The Options method displays a modal dialog box where the user can change the submission options for a message.
   *
   * @param     parentWindow A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object options  (
              Object parentWindow) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * copyTo. The CopyTo method makes a copy of the Message object in another folder.
   *
   * @param     folderID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object copyTo  (
              Object folderID,
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * moveTo. The MoveTo method relocates the Message object to another folder.
   *
   * @param     folderID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object moveTo  (
              Object folderID,
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * send. The Send method sends the message to the recipients through the messaging system.
   *
   * @param     saveCopy A Variant (in, optional, pass null if not required)
   * @param     showDialog A Variant (in, optional, pass null if not required)
   * @param     parentWindow A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object send  (
              Object saveCopy,
              Object showDialog,
              Object parentWindow) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * respond. The Respond method returns a MeetingItem object for responding to a meeting request for an appointment.
   *
   * @param     respondType A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object respond  (
              Object respondType) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * forward. The Forward method returns a new Message object that can be used to forward the current message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object forward  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getRecurrencePattern. The GetRecurrencePattern method returns a RecurrencePattern object defining the recurrence attributes of an appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getRecurrencePattern  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * clearRecurrencePattern. The ClearRecurrencePattern method removes any recurrence settings from this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object clearRecurrencePattern  () throws java.io.IOException, com.linar.jintegra.AutomationException;


  // Constants to help J-Integra for COM dynamically map DCOM invocations to
  // interface members.  Don't worry, you will never need to explicitly use these constants.
  int IIDef9203e7_b9a5_101b_acc1_00aa00423326 = 1;
  /** Dummy reference to interface proxy to make sure it gets compiled */
  int xxDummy = AppointmentItemProxy.xxDummy;
  /** Used internally by J-Integra for COM, please ignore */
  String IID = "00020400-0000-0000-C000-000000000046";
  String DISPID_20_GET_NAME = "getApplication";
  String DISPID_20_PUT_NAME = "setApplication";
  String DISPID_25_GET_NAME = "getParent";
  String DISPID_25_PUT_NAME = "setParent";
  String DISPID_34_GET_NAME = "getSession";
  String DISPID_34_PUT_NAME = "setSession";
  String DISPID_6_GET_NAME = "zz_getClass";
  String DISPID_6_PUT_NAME = "setClass";
  String DISPID_49_GET_NAME = "getMAPIOBJECT";
  String DISPID_49_PUT_NAME = "setMAPIOBJECT";
  String DISPID_51_GET_NAME = "getFolderID";
  String DISPID_51_PUT_NAME = "setFolderID";
  String DISPID_52_GET_NAME = "getStoreID";
  String DISPID_52_PUT_NAME = "setStoreID";
  String DISPID_14_GET_NAME = "getID";
  String DISPID_14_PUT_NAME = "setID";
  String DISPID_17_GET_NAME = "getType";
  String DISPID_17_PUT_NAME = "setType";
  String DISPID_36_GET_NAME = "getSize";
  String DISPID_36_PUT_NAME = "setSize";
  String DISPID_27_GET_NAME = "getImportance";
  String DISPID_27_PUT_NAME = "setImportance";
  String DISPID_38_GET_NAME = "getSubject";
  String DISPID_38_PUT_NAME = "setSubject";
  String DISPID_32_GET_NAME = "getSender";
  String DISPID_32_PUT_NAME = "setSender";
  String DISPID_41_GET_NAME = "getTimeSent";
  String DISPID_41_PUT_NAME = "setTimeSent";
  String DISPID_40_GET_NAME = "getTimeReceived";
  String DISPID_40_PUT_NAME = "setTimeReceived";
  String DISPID_39_GET_NAME = "getText";
  String DISPID_39_PUT_NAME = "setText";
  String DISPID_33_GET_NAME = "getSent";
  String DISPID_33_PUT_NAME = "setSent";
  String DISPID_18_GET_NAME = "getSubmitted";
  String DISPID_18_PUT_NAME = "setSubmitted";
  String DISPID_42_GET_NAME = "getUnread";
  String DISPID_42_PUT_NAME = "setUnread";
  String DISPID_35_GET_NAME = "getSigned";
  String DISPID_35_PUT_NAME = "setSigned";
  String DISPID_10_GET_NAME = "getEncrypted";
  String DISPID_10_PUT_NAME = "setEncrypted";
  String DISPID_30_GET_NAME = "getReadReceipt";
  String DISPID_30_PUT_NAME = "setReadReceipt";
  String DISPID_50_GET_NAME = "getDeliveryReceipt";
  String DISPID_50_PUT_NAME = "setDeliveryReceipt";
  String DISPID_8_GET_NAME = "getConversation";
  String DISPID_8_PUT_NAME = "setConversation";
  String DISPID_55_GET_NAME = "getConversationIndex";
  String DISPID_55_PUT_NAME = "setConversationIndex";
  String DISPID_54_GET_NAME = "getConversationTopic";
  String DISPID_54_PUT_NAME = "setConversationTopic";
  String DISPID_12_GET_NAME = "getFields";
  String DISPID_12_PUT_NAME = "setFields";
  String DISPID_28_GET_NAME = "getRecipients";
  String DISPID_28_PUT_NAME = "setRecipients";
  String DISPID_5_GET_NAME = "getAttachments";
  String DISPID_5_PUT_NAME = "setAttachments";
  String DISPID_96_GET_NAME = "getCategories";
  String DISPID_96_PUT_NAME = "setCategories";
  String DISPID_97_GET_NAME = "getTimeCreated";
  String DISPID_97_PUT_NAME = "setTimeCreated";
  String DISPID_98_GET_NAME = "getTimeExpired";
  String DISPID_98_PUT_NAME = "setTimeExpired";
  String DISPID_300_GET_NAME = "getSensitivity";
  String DISPID_300_PUT_NAME = "setSensitivity";
  String DISPID_301_GET_NAME = "getTimeLastModified";
  String DISPID_301_PUT_NAME = "setTimeLastModified";
  String DISPID_302_GET_NAME = "getAllDayEvent";
  String DISPID_302_PUT_NAME = "setAllDayEvent";
  String DISPID_303_GET_NAME = "getBusyStatus";
  String DISPID_303_PUT_NAME = "setBusyStatus";
  String DISPID_304_GET_NAME = "getDuration";
  String DISPID_304_PUT_NAME = "setDuration";
  String DISPID_89_GET_NAME = "getEndTime";
  String DISPID_89_PUT_NAME = "setEndTime";
  String DISPID_88_GET_NAME = "getStartTime";
  String DISPID_88_PUT_NAME = "setStartTime";
  String DISPID_305_GET_NAME = "getIsRecurring";
  String DISPID_305_PUT_NAME = "setIsRecurring";
  String DISPID_306_GET_NAME = "getLocation";
  String DISPID_306_PUT_NAME = "setLocation";
  String DISPID_307_GET_NAME = "getMeetingStatus";
  String DISPID_307_PUT_NAME = "setMeetingStatus";
  String DISPID_308_GET_NAME = "getOrganizer";
  String DISPID_308_PUT_NAME = "setOrganizer";
  String DISPID_309_GET_NAME = "getReminderMinutesBeforeStart";
  String DISPID_309_PUT_NAME = "setReminderMinutesBeforeStart";
  String DISPID_312_GET_NAME = "getReminderSet";
  String DISPID_312_PUT_NAME = "setReminderSet";
  String DISPID_314_GET_NAME = "getReplyTime";
  String DISPID_314_PUT_NAME = "setReplyTime";
  String DISPID_315_GET_NAME = "getResponseRequested";
  String DISPID_315_PUT_NAME = "setResponseRequested";
  String DISPID_325_GET_NAME = "getMeetingResponseStatus";
  String DISPID_325_PUT_NAME = "setMeetingResponseStatus";
  String DISPID_136_NAME = "isSameAs";
  String DISPID_106_NAME = "delete";
  String DISPID_132_NAME = "update";
  String DISPID_125_NAME = "options";
  String DISPID_104_NAME = "copyTo";
  String DISPID_120_NAME = "moveTo";
  String DISPID_131_NAME = "send";
  String DISPID_150_NAME = "respond";
  String DISPID_113_NAME = "forward";
  String DISPID_94_NAME = "getRecurrencePattern";
  String DISPID_151_NAME = "clearRecurrencePattern";
}
