package com.intrinsyc.cdo;

import com.linar.jintegra.*;
/**
 * Proxy for COM Interface 'AppointmentItem'. Generated 09-Jan-08 12:10:54 PM
 * from 'C:\Program Files\Common Files\System\MSMAPI\1033\CDO.DLL'<P>
 * Generated using com2java Version 2.8 (c) 2008 Intrinsyc Software International, Inc.  All rights reserved.
 * See  <A HREF="http://j-integra.intrinsyc.com/">http://j-integra.intrinsyc.com/</A><P>
 * Description: '<B>AppointmentItem object</B>'
 *
 * Generator Options:
 *   AwtForOcxs = False
 *   PromptForTypeLibraries = False
 *   RetryOnReject = False
 *   IDispatchOnly = False
 *   GenBeanInfo = False
 *   LowerCaseMemberNames = True
 *   TreatInStarAsIn = False
 *   ArraysAsObjects = False
 *   OmitRestrictedMethods = False
 *   ClashPrefix = zz_
 *   ImplementConflictingInterfaces = False
 *   DontRenameSameMethods = False
 *   RenameConflictingInterfaceMethods = False
 *   ReuseMethods = False
 *
 * Command Line Only Options:
 *   MakeClsidsPublic = False
 *   DontOverwrite = False
 */
public class AppointmentItemProxy extends com.linar.jintegra.Dispatch implements com.intrinsyc.cdo.AppointmentItem, java.io.Serializable {

  protected String getJintegraVersion() { return "2.8"; }

  static { com.intrinsyc.cdo.JIntegraInit.init(); }

  public static final Class targetClass = AppointmentItem.class;

  public AppointmentItemProxy(String CLSID, String host, AuthInfo authInfo) throws java.net.UnknownHostException, java.io.IOException{
    super(CLSID, AppointmentItem.IID, host, authInfo);
  }

  /** For internal use only */
  public AppointmentItemProxy() {}

  public AppointmentItemProxy(Object obj) throws java.io.IOException {
    super(obj, AppointmentItem.IID);
  }

  protected AppointmentItemProxy(Object obj, String iid) throws java.io.IOException {
    super(obj, iid);
  }

  protected AppointmentItemProxy(String CLSID, String iid, String host, AuthInfo authInfo) throws java.io.IOException {
    super(CLSID, iid, host, authInfo);
  }

  public void addListener(String iidStr, Object theListener, Object theSource) throws java.io.IOException {
    super.addListener(iidStr, theListener, theSource);
  }

  public void removeListener(String iidStr, Object theListener) throws java.io.IOException {
    super.removeListener(iidStr, theListener);
  }

  /**
   * getPropertyByName. Get the value of a property dynamically at run-time, based on its name
   *
   * @return    The value of the property.
   * @param     name The name of the property to get.
   * @exception java.lang.NoSuchFieldException If the property does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPropertyByName(String name) throws NoSuchFieldException, java.io.IOException, com.linar.jintegra.AutomationException {
    com.linar.jintegra.Variant parameters[] = {};
    return super.invoke(name, super.getDispatchIdOfName(name), 2, parameters).getVARIANT();
  }

  /**
   * getPropertyByName. Get the value of a property dynamically at run-time, based on its name and a parameter value
   *
   * @return    The value of the property.
   * @param     name The name of the property to get.
   * @param     rhs Parameter used when getting the property.
   * @exception java.lang.NoSuchFieldException If the property does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPropertyByName(String name, Object rhs) throws NoSuchFieldException, java.io.IOException, com.linar.jintegra.AutomationException {
    com.linar.jintegra.Variant parameters[] = {rhs == null ? new Variant("rhs", 10, 0x80020004L) : new Variant("rhs", 12, rhs)};
    return super.invoke(name, super.getDispatchIdOfName(name), 2, parameters).getVARIANT();
  }

  /**
   * invokeMethodByName. Invoke a method dynamically at run-time
   *
   * @return    The value returned by the method (null if none).
   * @param     name The name of the method to be invoked
   * @param     parameters One element for each parameter.  Use primitive type wrappers
   *            to pass primitive types (eg Integer to pass an int).
   * @exception java.lang.NoSuchMethodException If the method does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object invokeMethodByName(String name, Object[] parameters) throws NoSuchMethodException, java.io.IOException, com.linar.jintegra.AutomationException {
    com.linar.jintegra.Variant variantParameters[] = new com.linar.jintegra.Variant[parameters.length];
    for(int i = 0; i < parameters.length; i++) {
      variantParameters[i] = parameters[i] == null ? new Variant("p" + i, 10, 0x80020004L) :
	                                                   new Variant("p" + i, 12, parameters[i]);
    }
    try {
      return super.invoke(name, super.getDispatchIdOfName(name), 1, variantParameters).getVARIANT();
    } catch(NoSuchFieldException nsfe) {
      throw new NoSuchMethodException("There is no method called " + name);
    }
  }

  /**
   * invokeMethodByName. Invoke a method dynamically at run-time
   *
   * @return    The value returned by the method (null if none).
   * @param     name The name of the method to be invoked
   * @exception java.lang.NoSuchMethodException If the method does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object invokeMethodByName(String name) throws NoSuchMethodException, java.io.IOException, com.linar.jintegra.AutomationException {
      return invokeMethodByName(name, new Object[]{});
  }

  /**
   * getApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getApplication  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getApplication", 20, 2, parameters).getVARIANT();
  }

  /**
   * setApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setApplication  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setApplication", 20, 4, parameters);
    return;
  }

  /**
   * getParent. The Parent property returns the parent of the object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getParent  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getParent", 25, 2, parameters).getVARIANT();
  }

  /**
   * setParent. The Parent property returns the parent of the object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setParent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setParent", 25, 4, parameters);
    return;
  }

  /**
   * getSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSession  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSession", 34, 2, parameters).getVARIANT();
  }

  /**
   * setSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSession  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSession", 34, 4, parameters);
    return;
  }

  /**
   * zz_getClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object zz_getClass  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("zz_getClass", 6, 2, parameters).getVARIANT();
  }

  /**
   * setClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setClass  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setClass", 6, 4, parameters);
    return;
  }

  /**
   * getMAPIOBJECT. 
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMAPIOBJECT  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getMAPIOBJECT", 49, 2, parameters).getVARIANT();
  }

  /**
   * setMAPIOBJECT. 
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setMAPIOBJECT  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setMAPIOBJECT", 49, 4, parameters);
    return;
  }

  /**
   * getFolderID. The FolderID property returns the unique identifier of the folder in which the message resides.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFolderID  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getFolderID", 51, 2, parameters).getVARIANT();
  }

  /**
   * setFolderID. The FolderID property returns the unique identifier of the folder in which the message resides.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setFolderID  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setFolderID", 51, 4, parameters);
    return;
  }

  /**
   * getStoreID. The StoreID property represents the unique identifier for the message store that contains the message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getStoreID  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getStoreID", 52, 2, parameters).getVARIANT();
  }

  /**
   * setStoreID. The StoreID property represents the unique identifier for the message store that contains the message.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setStoreID  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setStoreID", 52, 4, parameters);
    return;
  }

  /**
   * getID. The ID property returns the unique identifier of the Message object as a string.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getID  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getID", 14, 2, parameters).getVARIANT();
  }

  /**
   * setID. The ID property returns the unique identifier of the Message object as a string.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setID  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setID", 14, 4, parameters);
    return;
  }

  /**
   * getType. The Type property returns or sets the message class for the message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getType  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getType", 17, 2, parameters).getVARIANT();
  }

  /**
   * setType. The Type property returns or sets the message class for the message.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setType  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setType", 17, 4, parameters);
    return;
  }

  /**
   * getSize. The Size property returns the approximate size in bytes of the message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSize  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSize", 36, 2, parameters).getVARIANT();
  }

  /**
   * setSize. The Size property returns the approximate size in bytes of the message.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSize  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSize", 36, 4, parameters);
    return;
  }

  /**
   * getImportance. The Importance property returns or sets the importance of the message as ActMsgNormal (the default), ActMsgLow, or ActMsgHigh.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getImportance  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getImportance", 27, 2, parameters).getVARIANT();
  }

  /**
   * setImportance. The Importance property returns or sets the importance of the message as ActMsgNormal (the default), ActMsgLow, or ActMsgHigh.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setImportance  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setImportance", 27, 4, parameters);
    return;
  }

  /**
   * getSubject. The Subject property returns or sets the subject of the message as a string.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSubject  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSubject", 38, 2, parameters).getVARIANT();
  }

  /**
   * setSubject. The Subject property returns or sets the subject of the message as a string.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSubject  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSubject", 38, 4, parameters);
    return;
  }

  /**
   * getSender. The Sender property returns or sets the sender of a message as an AddressEntry object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSender  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSender", 32, 2, parameters).getVARIANT();
  }

  /**
   * setSender. The Sender property returns or sets the sender of a message as an AddressEntry object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSender  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSender", 32, 4, parameters);
    return;
  }

  /**
   * getTimeSent. The TimeSent property sets or returns the date and time the message was sent as a vbDate variant data type.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getTimeSent  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getTimeSent", 41, 2, parameters).getVARIANT();
  }

  /**
   * setTimeSent. The TimeSent property sets or returns the date and time the message was sent as a vbDate variant data type.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setTimeSent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setTimeSent", 41, 4, parameters);
    return;
  }

  /**
   * getTimeReceived. The TimeReceived property sets or returns the date and time the message was received as a vbDate variant data type.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getTimeReceived  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getTimeReceived", 40, 2, parameters).getVARIANT();
  }

  /**
   * setTimeReceived. The TimeReceived property sets or returns the date and time the message was received as a vbDate variant data type.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setTimeReceived  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setTimeReceived", 40, 4, parameters);
    return;
  }

  /**
   * getText. The Text property returns or sets the text of the message as a string.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getText  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getText", 39, 2, parameters).getVARIANT();
  }

  /**
   * setText. The Text property returns or sets the text of the message as a string.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setText  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setText", 39, 4, parameters);
    return;
  }

  /**
   * getSent. The Sent property is True if the message has been sent through the messaging system.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSent  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSent", 33, 2, parameters).getVARIANT();
  }

  /**
   * setSent. The Sent property is True if the message has been sent through the messaging system.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSent", 33, 4, parameters);
    return;
  }

  /**
   * getSubmitted. The Submitted property is True when the message has been submitted.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSubmitted  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSubmitted", 18, 2, parameters).getVARIANT();
  }

  /**
   * setSubmitted. The Submitted property is True when the message has been submitted.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSubmitted  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSubmitted", 18, 4, parameters);
    return;
  }

  /**
   * getUnread. The Unread property is True if the message has not been read by the current user.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getUnread  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getUnread", 42, 2, parameters).getVARIANT();
  }

  /**
   * setUnread. The Unread property is True if the message has not been read by the current user.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setUnread  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setUnread", 42, 4, parameters);
    return;
  }

  /**
   * getSigned. The Signed property is True if the message has been tagged with a digital signature.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSigned  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSigned", 35, 2, parameters).getVARIANT();
  }

  /**
   * setSigned. The Signed property is True if the message has been tagged with a digital signature.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSigned  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSigned", 35, 4, parameters);
    return;
  }

  /**
   * getEncrypted. The Encrypted property is True if the message has been encrypted.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getEncrypted  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getEncrypted", 10, 2, parameters).getVARIANT();
  }

  /**
   * setEncrypted. The Encrypted property is True if the message has been encrypted.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setEncrypted  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setEncrypted", 10, 4, parameters);
    return;
  }

  /**
   * getReadReceipt. The ReadReceipt property is True if a read-receipt notification message is requested.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getReadReceipt  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getReadReceipt", 30, 2, parameters).getVARIANT();
  }

  /**
   * setReadReceipt. The ReadReceipt property is True if a read-receipt notification message is requested.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setReadReceipt  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setReadReceipt", 30, 4, parameters);
    return;
  }

  /**
   * getDeliveryReceipt. The DeliveryReceipt property is True if a delivery-receipt notification message is requested.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getDeliveryReceipt  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getDeliveryReceipt", 50, 2, parameters).getVARIANT();
  }

  /**
   * setDeliveryReceipt. The DeliveryReceipt property is True if a delivery-receipt notification message is requested.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setDeliveryReceipt  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setDeliveryReceipt", 50, 4, parameters);
    return;
  }

  /**
   * getConversation. The Conversation property is obsolete. It has been replaced by the ConversationIndex and ConversationTopic properties.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getConversation  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getConversation", 8, 2, parameters).getVARIANT();
  }

  /**
   * setConversation. The Conversation property is obsolete. It has been replaced by the ConversationIndex and ConversationTopic properties.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setConversation  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setConversation", 8, 4, parameters);
    return;
  }

  /**
   * getConversationIndex. The ConversationIndex property specifies the index to the conversation thread of the message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getConversationIndex  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getConversationIndex", 55, 2, parameters).getVARIANT();
  }

  /**
   * setConversationIndex. The ConversationIndex property specifies the index to the conversation thread of the message.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setConversationIndex  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setConversationIndex", 55, 4, parameters);
    return;
  }

  /**
   * getConversationTopic. The ConversationTopic property specifies the subject of the conversation thread of the message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getConversationTopic  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getConversationTopic", 54, 2, parameters).getVARIANT();
  }

  /**
   * setConversationTopic. The ConversationTopic property specifies the subject of the conversation thread of the message.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setConversationTopic  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setConversationTopic", 54, 4, parameters);
    return;
  }

  /**
   * getFields. The Fields property returns a single Field object or a Fields collection object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFields  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getFields", 12, 2, parameters).getVARIANT();
  }

  /**
   * setFields. The Fields property returns a single Field object or a Fields collection object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setFields  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setFields", 12, 4, parameters);
    return;
  }

  /**
   * getRecipients. The Recipients property returns a single Recipient object or a Recipients collection object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getRecipients  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getRecipients", 28, 2, parameters).getVARIANT();
  }

  /**
   * setRecipients. The Recipients property returns a single Recipient object or a Recipients collection object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setRecipients  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setRecipients", 28, 4, parameters);
    return;
  }

  /**
   * getAttachments. The Attachments property returns a single Attachment object or an Attachments collection object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAttachments  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getAttachments", 5, 2, parameters).getVARIANT();
  }

  /**
   * setAttachments. The Attachments property returns a single Attachment object or an Attachments collection object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setAttachments  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setAttachments", 5, 4, parameters);
    return;
  }

  /**
   * getCategories. The Categories property specifies the categories assigned to the message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getCategories  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getCategories", 96, 2, parameters).getVARIANT();
  }

  /**
   * setCategories. The Categories property specifies the categories assigned to the message.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setCategories  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setCategories", 96, 4, parameters);
    return;
  }

  /**
   * getTimeCreated. The TimeCreated property specifies the date/time the message was first saved.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getTimeCreated  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getTimeCreated", 97, 2, parameters).getVARIANT();
  }

  /**
   * setTimeCreated. The TimeCreated property specifies the date/time the message was first saved.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setTimeCreated  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setTimeCreated", 97, 4, parameters);
    return;
  }

  /**
   * getTimeExpired. The TimeExpired property specifies the date/time the message will expire.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getTimeExpired  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getTimeExpired", 98, 2, parameters).getVARIANT();
  }

  /**
   * setTimeExpired. The TimeExpired property specifies the date/time the message will expire.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setTimeExpired  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setTimeExpired", 98, 4, parameters);
    return;
  }

  /**
   * getSensitivity. The Sensitivity property specifies the sensitivity of the message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSensitivity  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSensitivity", 300, 2, parameters).getVARIANT();
  }

  /**
   * setSensitivity. The Sensitivity property specifies the sensitivity of the message.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSensitivity  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSensitivity", 300, 4, parameters);
    return;
  }

  /**
   * getTimeLastModified. The TimeLastModified property specifies the date/time the message was most recently saved.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getTimeLastModified  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getTimeLastModified", 301, 2, parameters).getVARIANT();
  }

  /**
   * setTimeLastModified. The TimeLastModified property specifies the date/time the message was most recently saved.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setTimeLastModified  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setTimeLastModified", 301, 4, parameters);
    return;
  }

  /**
   * getAllDayEvent. The AllDayEvent property indicates whether this appointment is an all-day event.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAllDayEvent  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getAllDayEvent", 302, 2, parameters).getVARIANT();
  }

  /**
   * setAllDayEvent. The AllDayEvent property indicates whether this appointment is an all-day event.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setAllDayEvent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setAllDayEvent", 302, 4, parameters);
    return;
  }

  /**
   * getBusyStatus. The BusyStatus property returns or sets the busy status of this messaging user for this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getBusyStatus  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getBusyStatus", 303, 2, parameters).getVARIANT();
  }

  /**
   * setBusyStatus. The BusyStatus property returns or sets the busy status of this messaging user for this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setBusyStatus  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setBusyStatus", 303, 4, parameters);
    return;
  }

  /**
   * getDuration. The Duration property returns the duration of this appointment in minutes.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getDuration  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getDuration", 304, 2, parameters).getVARIANT();
  }

  /**
   * setDuration. The Duration property returns the duration of this appointment in minutes.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setDuration  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setDuration", 304, 4, parameters);
    return;
  }

  /**
   * getEndTime. The EndTime property returns or sets the ending date/time of this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getEndTime  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getEndTime", 89, 2, parameters).getVARIANT();
  }

  /**
   * setEndTime. The EndTime property returns or sets the ending date/time of this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setEndTime  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setEndTime", 89, 4, parameters);
    return;
  }

  /**
   * getStartTime. The StartTime property returns or sets the starting date/time of this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getStartTime  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getStartTime", 88, 2, parameters).getVARIANT();
  }

  /**
   * setStartTime. The StartTime property returns or sets the starting date/time of this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setStartTime  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setStartTime", 88, 4, parameters);
    return;
  }

  /**
   * getIsRecurring. The IsRecurring property indicates whether this appointment is specified as recurring.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getIsRecurring  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getIsRecurring", 305, 2, parameters).getVARIANT();
  }

  /**
   * setIsRecurring. The IsRecurring property indicates whether this appointment is specified as recurring.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setIsRecurring  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setIsRecurring", 305, 4, parameters);
    return;
  }

  /**
   * getLocation. The Location property returns or sets the location of this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getLocation  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getLocation", 306, 2, parameters).getVARIANT();
  }

  /**
   * setLocation. The Location property returns or sets the location of this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setLocation  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setLocation", 306, 4, parameters);
    return;
  }

  /**
   * getMeetingStatus. The MeetingStatus property returns or sets the overall meeting status of this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMeetingStatus  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getMeetingStatus", 307, 2, parameters).getVARIANT();
  }

  /**
   * setMeetingStatus. The MeetingStatus property returns or sets the overall meeting status of this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setMeetingStatus  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setMeetingStatus", 307, 4, parameters);
    return;
  }

  /**
   * getOrganizer. The Organizer property returns the messaging user that initiated this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOrganizer  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getOrganizer", 308, 2, parameters).getVARIANT();
  }

  /**
   * setOrganizer. The Organizer property returns the messaging user that initiated this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOrganizer  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setOrganizer", 308, 4, parameters);
    return;
  }

  /**
   * getReminderMinutesBeforeStart. The ReminderMinutesBeforeStart property indicates how many minutes before the start of this appointment a reminder should be issued.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getReminderMinutesBeforeStart  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getReminderMinutesBeforeStart", 309, 2, parameters).getVARIANT();
  }

  /**
   * setReminderMinutesBeforeStart. The ReminderMinutesBeforeStart property indicates how many minutes before the start of this appointment a reminder should be issued.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setReminderMinutesBeforeStart  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setReminderMinutesBeforeStart", 309, 4, parameters);
    return;
  }

  /**
   * getReminderSet. The ReminderSet property indicates whether this messaging user is to be reminded of this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getReminderSet  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getReminderSet", 312, 2, parameters).getVARIANT();
  }

  /**
   * setReminderSet. The ReminderSet property indicates whether this messaging user is to be reminded of this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setReminderSet  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setReminderSet", 312, 4, parameters);
    return;
  }

  /**
   * getReplyTime. The ReplyTime property returns or sets the date/time by which action on this appointment is expected.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getReplyTime  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getReplyTime", 314, 2, parameters).getVARIANT();
  }

  /**
   * setReplyTime. The ReplyTime property returns or sets the date/time by which action on this appointment is expected.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setReplyTime  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setReplyTime", 314, 4, parameters);
    return;
  }

  /**
   * getResponseRequested. The ResponseRequested property indicates whether a response is requested for this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getResponseRequested  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getResponseRequested", 315, 2, parameters).getVARIANT();
  }

  /**
   * setResponseRequested. The ResponseRequested property indicates whether a response is requested for this appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setResponseRequested  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setResponseRequested", 315, 4, parameters);
    return;
  }

  /**
   * getMeetingResponseStatus. The MeetingResponseStatus property returns or sets the overall status of this appointment for this messaging user.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMeetingResponseStatus  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getMeetingResponseStatus", 325, 2, parameters).getVARIANT();
  }

  /**
   * setMeetingResponseStatus. The MeetingResponseStatus property returns or sets the overall status of this appointment for this messaging user.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setMeetingResponseStatus  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setMeetingResponseStatus", 325, 4, parameters);
    return;
  }

  /**
   * isSameAs. The IsSameAs method returns True if the Message object is the same as the Message object being compared against.
   *
   * @param     object A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object isSameAs  (
              Object object) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {object == null ? new Variant("object", 0, 0x80020004L) : new Variant("object", 12, object),};
    return invoke("isSameAs", 136, 1, parameters).getVARIANT();
  }

  /**
   * delete. The Delete method deletes the Message object.
   *
   * @param     deletedItems A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object delete  (
              Object deletedItems) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {deletedItems == null ? new Variant("deletedItems", 10, 0x80020004L) : new Variant("deletedItems", 12, deletedItems),};
    return invoke("delete", 106, 1, parameters).getVARIANT();
  }

  /**
   * update. The Update method saves the message in the messaging system.
   *
   * @param     makePermanent A Variant (in, optional, pass null if not required)
   * @param     refreshObject A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object update  (
              Object makePermanent,
              Object refreshObject) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {makePermanent == null ? new Variant("makePermanent", 10, 0x80020004L) : new Variant("makePermanent", 12, makePermanent),
                                         refreshObject == null ? new Variant("refreshObject", 10, 0x80020004L) : new Variant("refreshObject", 12, refreshObject),};
    return invoke("update", 132, 1, parameters).getVARIANT();
  }

  /**
   * options. The Options method displays a modal dialog box where the user can change the submission options for a message.
   *
   * @param     parentWindow A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object options  (
              Object parentWindow) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {parentWindow == null ? new Variant("parentWindow", 10, 0x80020004L) : new Variant("parentWindow", 12, parentWindow),};
    return invoke("options", 125, 1, parameters).getVARIANT();
  }

  /**
   * copyTo. The CopyTo method makes a copy of the Message object in another folder.
   *
   * @param     folderID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object copyTo  (
              Object folderID,
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {folderID == null ? new Variant("folderID", 0, 0x80020004L) : new Variant("folderID", 12, folderID),
                                         storeID == null ? new Variant("storeID", 10, 0x80020004L) : new Variant("storeID", 12, storeID),};
    return invoke("copyTo", 104, 1, parameters).getVARIANT();
  }

  /**
   * moveTo. The MoveTo method relocates the Message object to another folder.
   *
   * @param     folderID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object moveTo  (
              Object folderID,
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {folderID == null ? new Variant("folderID", 0, 0x80020004L) : new Variant("folderID", 12, folderID),
                                         storeID == null ? new Variant("storeID", 10, 0x80020004L) : new Variant("storeID", 12, storeID),};
    return invoke("moveTo", 120, 1, parameters).getVARIANT();
  }

  /**
   * send. The Send method sends the message to the recipients through the messaging system.
   *
   * @param     saveCopy A Variant (in, optional, pass null if not required)
   * @param     showDialog A Variant (in, optional, pass null if not required)
   * @param     parentWindow A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object send  (
              Object saveCopy,
              Object showDialog,
              Object parentWindow) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {saveCopy == null ? new Variant("saveCopy", 10, 0x80020004L) : new Variant("saveCopy", 12, saveCopy),
                                         showDialog == null ? new Variant("showDialog", 10, 0x80020004L) : new Variant("showDialog", 12, showDialog),
                                         parentWindow == null ? new Variant("parentWindow", 10, 0x80020004L) : new Variant("parentWindow", 12, parentWindow),};
    return invoke("send", 131, 1, parameters).getVARIANT();
  }

  /**
   * respond. The Respond method returns a MeetingItem object for responding to a meeting request for an appointment.
   *
   * @param     respondType A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object respond  (
              Object respondType) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {respondType == null ? new Variant("respondType", 0, 0x80020004L) : new Variant("respondType", 12, respondType),};
    return invoke("respond", 150, 1, parameters).getVARIANT();
  }

  /**
   * forward. The Forward method returns a new Message object that can be used to forward the current message.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object forward  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("forward", 113, 1, parameters).getVARIANT();
  }

  /**
   * getRecurrencePattern. The GetRecurrencePattern method returns a RecurrencePattern object defining the recurrence attributes of an appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getRecurrencePattern  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getRecurrencePattern", 94, 1, parameters).getVARIANT();
  }

  /**
   * clearRecurrencePattern. The ClearRecurrencePattern method removes any recurrence settings from this appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object clearRecurrencePattern  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("clearRecurrencePattern", 151, 1, parameters).getVARIANT();
  }

  /** Dummy reference from interface to proxy to make sure proxy gets compiled */
  static final int xxDummy = 0;

  static {
    com.linar.jintegra.InterfaceDesc.add("ef9203e7-b9a5-101b-acc1-00aa00423326", com.intrinsyc.cdo.AppointmentItemProxy.class, null, 0, null );
  }
}
