package com.intrinsyc.cdo;

/**
 * COM Interface 'Folder'. Generated 09-Jan-08 12:10:54 PM
 * from 'C:\Program Files\Common Files\System\MSMAPI\1033\CDO.DLL'<P>
 * Generated using com2java Version 2.8 (c) 2008 Intrinsyc Software International, Inc.  All rights reserved.
 * See  <A HREF="http://j-integra.intrinsyc.com/">http://j-integra.intrinsyc.com/</A><P>
 * Description: '<B>Folder object</B>'
 *
 * Generator Options:
 *   AwtForOcxs = False
 *   PromptForTypeLibraries = False
 *   RetryOnReject = False
 *   IDispatchOnly = False
 *   GenBeanInfo = False
 *   LowerCaseMemberNames = True
 *   TreatInStarAsIn = False
 *   ArraysAsObjects = False
 *   OmitRestrictedMethods = False
 *   ClashPrefix = zz_
 *   ImplementConflictingInterfaces = False
 *   DontRenameSameMethods = False
 *   RenameConflictingInterfaceMethods = False
 *   ReuseMethods = False
 *
 * Command Line Only Options:
 *   MakeClsidsPublic = False
 *   DontOverwrite = False
 */
public interface Folder extends java.io.Serializable {
  /**
   * getApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getApplication  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setApplication  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getParent. The Parent property returns the parent of the object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getParent  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setParent. The Parent property returns the parent of the object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setParent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSession  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSession  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * zz_getClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object zz_getClass  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setClass  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getMAPIOBJECT. 
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMAPIOBJECT  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setMAPIOBJECT. 
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setMAPIOBJECT  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getName. The Name property returns or sets the name of the Folder object as a string.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getName  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setName. The Name property returns or sets the name of the Folder object as a string.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setName  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getID. The ID property returns the unique identifier of the Folder object as a string.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getID  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setID. The ID property returns the unique identifier of the Folder object as a string.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setID  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getFolderID. The FolderID property returns the unique identifier of the subfolder's parent folder as a string.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFolderID  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setFolderID. The FolderID property returns the unique identifier of the subfolder's parent folder as a string.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setFolderID  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getStoreID. The StoreID property returns the unique identifier of the InfoStore object in which the Folder object resides.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getStoreID  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setStoreID. The StoreID property returns the unique identifier of the InfoStore object in which the Folder object resides.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setStoreID  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getFolders. The Folders property returns a Folders collection of subfolders within the folder.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFolders  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setFolders. The Folders property returns a Folders collection of subfolders within the folder.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setFolders  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getMessages. The Messages property returns a Messages collection object within the folder.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMessages  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setMessages. The Messages property returns a Messages collection object within the folder.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setMessages  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getFields. The Fields property returns a single Field object or Fields collection object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFields  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setFields. The Fields property returns a single Field object or Fields collection object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setFields  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getHiddenMessages. The HiddenMessages property returns a HiddenMessages collection object within the folder.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getHiddenMessages  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setHiddenMessages. The HiddenMessages property returns a HiddenMessages collection object within the folder.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setHiddenMessages  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * update. The Update method saves changes to the Folder object.
   *
   * @param     makePermanent A Variant (in, optional, pass null if not required)
   * @param     refreshObject A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object update  (
              Object makePermanent,
              Object refreshObject) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * copyTo. The CopyTo method makes a copy of the Folder object at another folder hierarchy location.
   *
   * @param     folderID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @param     name A Variant (in, optional, pass null if not required)
   * @param     copySubfolders A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object copyTo  (
              Object folderID,
              Object storeID,
              Object name,
              Object copySubfolders) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * moveTo. The MoveTo method relocates the Folder object to another folder hierarchy location.
   *
   * @param     folderID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object moveTo  (
              Object folderID,
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * delete. The Delete method deletes the Message object.
   *
   * @param     deletedItems A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object delete  (
              Object deletedItems) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * isSameAs. The IsSameAs method returns True if the Folder object is the same as the Folder object being compared against.
   *
   * @param     object A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object isSameAs  (
              Object object) throws java.io.IOException, com.linar.jintegra.AutomationException;


  // Constants to help J-Integra for COM dynamically map DCOM invocations to
  // interface members.  Don't worry, you will never need to explicitly use these constants.
  int IID3fa7dea9_6438_101b_acc1_00aa00423326 = 1;
  /** Dummy reference to interface proxy to make sure it gets compiled */
  int xxDummy = FolderProxy.xxDummy;
  /** Used internally by J-Integra for COM, please ignore */
  String IID = "00020400-0000-0000-C000-000000000046";
  String DISPID_20_GET_NAME = "getApplication";
  String DISPID_20_PUT_NAME = "setApplication";
  String DISPID_25_GET_NAME = "getParent";
  String DISPID_25_PUT_NAME = "setParent";
  String DISPID_34_GET_NAME = "getSession";
  String DISPID_34_PUT_NAME = "setSession";
  String DISPID_6_GET_NAME = "zz_getClass";
  String DISPID_6_PUT_NAME = "setClass";
  String DISPID_49_GET_NAME = "getMAPIOBJECT";
  String DISPID_49_PUT_NAME = "setMAPIOBJECT";
  String DISPID_23_GET_NAME = "getName";
  String DISPID_23_PUT_NAME = "setName";
  String DISPID_14_GET_NAME = "getID";
  String DISPID_14_PUT_NAME = "setID";
  String DISPID_51_GET_NAME = "getFolderID";
  String DISPID_51_PUT_NAME = "setFolderID";
  String DISPID_52_GET_NAME = "getStoreID";
  String DISPID_52_PUT_NAME = "setStoreID";
  String DISPID_13_GET_NAME = "getFolders";
  String DISPID_13_PUT_NAME = "setFolders";
  String DISPID_22_GET_NAME = "getMessages";
  String DISPID_22_PUT_NAME = "setMessages";
  String DISPID_12_GET_NAME = "getFields";
  String DISPID_12_PUT_NAME = "setFields";
  String DISPID_327_GET_NAME = "getHiddenMessages";
  String DISPID_327_PUT_NAME = "setHiddenMessages";
  String DISPID_132_NAME = "update";
  String DISPID_104_NAME = "copyTo";
  String DISPID_120_NAME = "moveTo";
  String DISPID_106_NAME = "delete";
  String DISPID_136_NAME = "isSameAs";
}
