package com.intrinsyc.cdo;

import com.linar.jintegra.*;
/**
 * Proxy for COM Interface 'Folder'. Generated 09-Jan-08 12:10:54 PM
 * from 'C:\Program Files\Common Files\System\MSMAPI\1033\CDO.DLL'<P>
 * Generated using com2java Version 2.8 (c) 2008 Intrinsyc Software International, Inc.  All rights reserved.
 * See  <A HREF="http://j-integra.intrinsyc.com/">http://j-integra.intrinsyc.com/</A><P>
 * Description: '<B>Folder object</B>'
 *
 * Generator Options:
 *   AwtForOcxs = False
 *   PromptForTypeLibraries = False
 *   RetryOnReject = False
 *   IDispatchOnly = False
 *   GenBeanInfo = False
 *   LowerCaseMemberNames = True
 *   TreatInStarAsIn = False
 *   ArraysAsObjects = False
 *   OmitRestrictedMethods = False
 *   ClashPrefix = zz_
 *   ImplementConflictingInterfaces = False
 *   DontRenameSameMethods = False
 *   RenameConflictingInterfaceMethods = False
 *   ReuseMethods = False
 *
 * Command Line Only Options:
 *   MakeClsidsPublic = False
 *   DontOverwrite = False
 */
public class FolderProxy extends com.linar.jintegra.Dispatch implements com.intrinsyc.cdo.Folder, java.io.Serializable {

  protected String getJintegraVersion() { return "2.8"; }

  static { com.intrinsyc.cdo.JIntegraInit.init(); }

  public static final Class targetClass = Folder.class;

  public FolderProxy(String CLSID, String host, AuthInfo authInfo) throws java.net.UnknownHostException, java.io.IOException{
    super(CLSID, Folder.IID, host, authInfo);
  }

  /** For internal use only */
  public FolderProxy() {}

  public FolderProxy(Object obj) throws java.io.IOException {
    super(obj, Folder.IID);
  }

  protected FolderProxy(Object obj, String iid) throws java.io.IOException {
    super(obj, iid);
  }

  protected FolderProxy(String CLSID, String iid, String host, AuthInfo authInfo) throws java.io.IOException {
    super(CLSID, iid, host, authInfo);
  }

  public void addListener(String iidStr, Object theListener, Object theSource) throws java.io.IOException {
    super.addListener(iidStr, theListener, theSource);
  }

  public void removeListener(String iidStr, Object theListener) throws java.io.IOException {
    super.removeListener(iidStr, theListener);
  }

  /**
   * getPropertyByName. Get the value of a property dynamically at run-time, based on its name
   *
   * @return    The value of the property.
   * @param     name The name of the property to get.
   * @exception java.lang.NoSuchFieldException If the property does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPropertyByName(String name) throws NoSuchFieldException, java.io.IOException, com.linar.jintegra.AutomationException {
    com.linar.jintegra.Variant parameters[] = {};
    return super.invoke(name, super.getDispatchIdOfName(name), 2, parameters).getVARIANT();
  }

  /**
   * getPropertyByName. Get the value of a property dynamically at run-time, based on its name and a parameter value
   *
   * @return    The value of the property.
   * @param     name The name of the property to get.
   * @param     rhs Parameter used when getting the property.
   * @exception java.lang.NoSuchFieldException If the property does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPropertyByName(String name, Object rhs) throws NoSuchFieldException, java.io.IOException, com.linar.jintegra.AutomationException {
    com.linar.jintegra.Variant parameters[] = {rhs == null ? new Variant("rhs", 10, 0x80020004L) : new Variant("rhs", 12, rhs)};
    return super.invoke(name, super.getDispatchIdOfName(name), 2, parameters).getVARIANT();
  }

  /**
   * invokeMethodByName. Invoke a method dynamically at run-time
   *
   * @return    The value returned by the method (null if none).
   * @param     name The name of the method to be invoked
   * @param     parameters One element for each parameter.  Use primitive type wrappers
   *            to pass primitive types (eg Integer to pass an int).
   * @exception java.lang.NoSuchMethodException If the method does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object invokeMethodByName(String name, Object[] parameters) throws NoSuchMethodException, java.io.IOException, com.linar.jintegra.AutomationException {
    com.linar.jintegra.Variant variantParameters[] = new com.linar.jintegra.Variant[parameters.length];
    for(int i = 0; i < parameters.length; i++) {
      variantParameters[i] = parameters[i] == null ? new Variant("p" + i, 10, 0x80020004L) :
	                                                   new Variant("p" + i, 12, parameters[i]);
    }
    try {
      return super.invoke(name, super.getDispatchIdOfName(name), 1, variantParameters).getVARIANT();
    } catch(NoSuchFieldException nsfe) {
      throw new NoSuchMethodException("There is no method called " + name);
    }
  }

  /**
   * invokeMethodByName. Invoke a method dynamically at run-time
   *
   * @return    The value returned by the method (null if none).
   * @param     name The name of the method to be invoked
   * @exception java.lang.NoSuchMethodException If the method does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object invokeMethodByName(String name) throws NoSuchMethodException, java.io.IOException, com.linar.jintegra.AutomationException {
      return invokeMethodByName(name, new Object[]{});
  }

  /**
   * getApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getApplication  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getApplication", 20, 2, parameters).getVARIANT();
  }

  /**
   * setApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setApplication  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setApplication", 20, 4, parameters);
    return;
  }

  /**
   * getParent. The Parent property returns the parent of the object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getParent  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getParent", 25, 2, parameters).getVARIANT();
  }

  /**
   * setParent. The Parent property returns the parent of the object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setParent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setParent", 25, 4, parameters);
    return;
  }

  /**
   * getSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSession  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSession", 34, 2, parameters).getVARIANT();
  }

  /**
   * setSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSession  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSession", 34, 4, parameters);
    return;
  }

  /**
   * zz_getClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object zz_getClass  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("zz_getClass", 6, 2, parameters).getVARIANT();
  }

  /**
   * setClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setClass  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setClass", 6, 4, parameters);
    return;
  }

  /**
   * getMAPIOBJECT. 
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMAPIOBJECT  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getMAPIOBJECT", 49, 2, parameters).getVARIANT();
  }

  /**
   * setMAPIOBJECT. 
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setMAPIOBJECT  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setMAPIOBJECT", 49, 4, parameters);
    return;
  }

  /**
   * getName. The Name property returns or sets the name of the Folder object as a string.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getName  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getName", 23, 2, parameters).getVARIANT();
  }

  /**
   * setName. The Name property returns or sets the name of the Folder object as a string.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setName  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setName", 23, 4, parameters);
    return;
  }

  /**
   * getID. The ID property returns the unique identifier of the Folder object as a string.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getID  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getID", 14, 2, parameters).getVARIANT();
  }

  /**
   * setID. The ID property returns the unique identifier of the Folder object as a string.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setID  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setID", 14, 4, parameters);
    return;
  }

  /**
   * getFolderID. The FolderID property returns the unique identifier of the subfolder's parent folder as a string.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFolderID  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getFolderID", 51, 2, parameters).getVARIANT();
  }

  /**
   * setFolderID. The FolderID property returns the unique identifier of the subfolder's parent folder as a string.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setFolderID  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setFolderID", 51, 4, parameters);
    return;
  }

  /**
   * getStoreID. The StoreID property returns the unique identifier of the InfoStore object in which the Folder object resides.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getStoreID  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getStoreID", 52, 2, parameters).getVARIANT();
  }

  /**
   * setStoreID. The StoreID property returns the unique identifier of the InfoStore object in which the Folder object resides.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setStoreID  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setStoreID", 52, 4, parameters);
    return;
  }

  /**
   * getFolders. The Folders property returns a Folders collection of subfolders within the folder.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFolders  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getFolders", 13, 2, parameters).getVARIANT();
  }

  /**
   * setFolders. The Folders property returns a Folders collection of subfolders within the folder.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setFolders  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setFolders", 13, 4, parameters);
    return;
  }

  /**
   * getMessages. The Messages property returns a Messages collection object within the folder.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMessages  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getMessages", 22, 2, parameters).getVARIANT();
  }

  /**
   * setMessages. The Messages property returns a Messages collection object within the folder.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setMessages  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setMessages", 22, 4, parameters);
    return;
  }

  /**
   * getFields. The Fields property returns a single Field object or Fields collection object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFields  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getFields", 12, 2, parameters).getVARIANT();
  }

  /**
   * setFields. The Fields property returns a single Field object or Fields collection object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setFields  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setFields", 12, 4, parameters);
    return;
  }

  /**
   * getHiddenMessages. The HiddenMessages property returns a HiddenMessages collection object within the folder.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getHiddenMessages  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getHiddenMessages", 327, 2, parameters).getVARIANT();
  }

  /**
   * setHiddenMessages. The HiddenMessages property returns a HiddenMessages collection object within the folder.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setHiddenMessages  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setHiddenMessages", 327, 4, parameters);
    return;
  }

  /**
   * update. The Update method saves changes to the Folder object.
   *
   * @param     makePermanent A Variant (in, optional, pass null if not required)
   * @param     refreshObject A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object update  (
              Object makePermanent,
              Object refreshObject) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {makePermanent == null ? new Variant("makePermanent", 10, 0x80020004L) : new Variant("makePermanent", 12, makePermanent),
                                         refreshObject == null ? new Variant("refreshObject", 10, 0x80020004L) : new Variant("refreshObject", 12, refreshObject),};
    return invoke("update", 132, 1, parameters).getVARIANT();
  }

  /**
   * copyTo. The CopyTo method makes a copy of the Folder object at another folder hierarchy location.
   *
   * @param     folderID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @param     name A Variant (in, optional, pass null if not required)
   * @param     copySubfolders A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object copyTo  (
              Object folderID,
              Object storeID,
              Object name,
              Object copySubfolders) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {folderID == null ? new Variant("folderID", 0, 0x80020004L) : new Variant("folderID", 12, folderID),
                                         storeID == null ? new Variant("storeID", 10, 0x80020004L) : new Variant("storeID", 12, storeID),
                                         name == null ? new Variant("name", 10, 0x80020004L) : new Variant("name", 12, name),
                                         copySubfolders == null ? new Variant("copySubfolders", 10, 0x80020004L) : new Variant("copySubfolders", 12, copySubfolders),};
    return invoke("copyTo", 104, 1, parameters).getVARIANT();
  }

  /**
   * moveTo. The MoveTo method relocates the Folder object to another folder hierarchy location.
   *
   * @param     folderID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object moveTo  (
              Object folderID,
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {folderID == null ? new Variant("folderID", 0, 0x80020004L) : new Variant("folderID", 12, folderID),
                                         storeID == null ? new Variant("storeID", 10, 0x80020004L) : new Variant("storeID", 12, storeID),};
    return invoke("moveTo", 120, 1, parameters).getVARIANT();
  }

  /**
   * delete. The Delete method deletes the Message object.
   *
   * @param     deletedItems A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object delete  (
              Object deletedItems) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {deletedItems == null ? new Variant("deletedItems", 10, 0x80020004L) : new Variant("deletedItems", 12, deletedItems),};
    return invoke("delete", 106, 1, parameters).getVARIANT();
  }

  /**
   * isSameAs. The IsSameAs method returns True if the Folder object is the same as the Folder object being compared against.
   *
   * @param     object A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object isSameAs  (
              Object object) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {object == null ? new Variant("object", 0, 0x80020004L) : new Variant("object", 12, object),};
    return invoke("isSameAs", 136, 1, parameters).getVARIANT();
  }

  /** Dummy reference from interface to proxy to make sure proxy gets compiled */
  static final int xxDummy = 0;

  static {
    com.linar.jintegra.InterfaceDesc.add("3fa7dea9-6438-101b-acc1-00aa00423326", com.intrinsyc.cdo.FolderProxy.class, null, 0, null );
  }
}
