package com.intrinsyc.cdo;

import com.linar.jintegra.*;
/**
 * Proxy for COM Interface 'MessageFilter'. Generated 09-Jan-08 12:10:54 PM
 * from 'C:\Program Files\Common Files\System\MSMAPI\1033\CDO.DLL'<P>
 * Generated using com2java Version 2.8 (c) 2008 Intrinsyc Software International, Inc.  All rights reserved.
 * See  <A HREF="http://j-integra.intrinsyc.com/">http://j-integra.intrinsyc.com/</A><P>
 * Description: '<B>MessageFilter object</B>'
 *
 * Generator Options:
 *   AwtForOcxs = False
 *   PromptForTypeLibraries = False
 *   RetryOnReject = False
 *   IDispatchOnly = False
 *   GenBeanInfo = False
 *   LowerCaseMemberNames = True
 *   TreatInStarAsIn = False
 *   ArraysAsObjects = False
 *   OmitRestrictedMethods = False
 *   ClashPrefix = zz_
 *   ImplementConflictingInterfaces = False
 *   DontRenameSameMethods = False
 *   RenameConflictingInterfaceMethods = False
 *   ReuseMethods = False
 *
 * Command Line Only Options:
 *   MakeClsidsPublic = False
 *   DontOverwrite = False
 */
public class MessageFilterProxy extends com.linar.jintegra.Dispatch implements com.intrinsyc.cdo.MessageFilter, java.io.Serializable {

  protected String getJintegraVersion() { return "2.8"; }

  static { com.intrinsyc.cdo.JIntegraInit.init(); }

  public static final Class targetClass = MessageFilter.class;

  public MessageFilterProxy(String CLSID, String host, AuthInfo authInfo) throws java.net.UnknownHostException, java.io.IOException{
    super(CLSID, MessageFilter.IID, host, authInfo);
  }

  /** For internal use only */
  public MessageFilterProxy() {}

  public MessageFilterProxy(Object obj) throws java.io.IOException {
    super(obj, MessageFilter.IID);
  }

  protected MessageFilterProxy(Object obj, String iid) throws java.io.IOException {
    super(obj, iid);
  }

  protected MessageFilterProxy(String CLSID, String iid, String host, AuthInfo authInfo) throws java.io.IOException {
    super(CLSID, iid, host, authInfo);
  }

  public void addListener(String iidStr, Object theListener, Object theSource) throws java.io.IOException {
    super.addListener(iidStr, theListener, theSource);
  }

  public void removeListener(String iidStr, Object theListener) throws java.io.IOException {
    super.removeListener(iidStr, theListener);
  }

  /**
   * getPropertyByName. Get the value of a property dynamically at run-time, based on its name
   *
   * @return    The value of the property.
   * @param     name The name of the property to get.
   * @exception java.lang.NoSuchFieldException If the property does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPropertyByName(String name) throws NoSuchFieldException, java.io.IOException, com.linar.jintegra.AutomationException {
    com.linar.jintegra.Variant parameters[] = {};
    return super.invoke(name, super.getDispatchIdOfName(name), 2, parameters).getVARIANT();
  }

  /**
   * getPropertyByName. Get the value of a property dynamically at run-time, based on its name and a parameter value
   *
   * @return    The value of the property.
   * @param     name The name of the property to get.
   * @param     rhs Parameter used when getting the property.
   * @exception java.lang.NoSuchFieldException If the property does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPropertyByName(String name, Object rhs) throws NoSuchFieldException, java.io.IOException, com.linar.jintegra.AutomationException {
    com.linar.jintegra.Variant parameters[] = {rhs == null ? new Variant("rhs", 10, 0x80020004L) : new Variant("rhs", 12, rhs)};
    return super.invoke(name, super.getDispatchIdOfName(name), 2, parameters).getVARIANT();
  }

  /**
   * invokeMethodByName. Invoke a method dynamically at run-time
   *
   * @return    The value returned by the method (null if none).
   * @param     name The name of the method to be invoked
   * @param     parameters One element for each parameter.  Use primitive type wrappers
   *            to pass primitive types (eg Integer to pass an int).
   * @exception java.lang.NoSuchMethodException If the method does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object invokeMethodByName(String name, Object[] parameters) throws NoSuchMethodException, java.io.IOException, com.linar.jintegra.AutomationException {
    com.linar.jintegra.Variant variantParameters[] = new com.linar.jintegra.Variant[parameters.length];
    for(int i = 0; i < parameters.length; i++) {
      variantParameters[i] = parameters[i] == null ? new Variant("p" + i, 10, 0x80020004L) :
	                                                   new Variant("p" + i, 12, parameters[i]);
    }
    try {
      return super.invoke(name, super.getDispatchIdOfName(name), 1, variantParameters).getVARIANT();
    } catch(NoSuchFieldException nsfe) {
      throw new NoSuchMethodException("There is no method called " + name);
    }
  }

  /**
   * invokeMethodByName. Invoke a method dynamically at run-time
   *
   * @return    The value returned by the method (null if none).
   * @param     name The name of the method to be invoked
   * @exception java.lang.NoSuchMethodException If the method does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object invokeMethodByName(String name) throws NoSuchMethodException, java.io.IOException, com.linar.jintegra.AutomationException {
      return invokeMethodByName(name, new Object[]{});
  }

  /**
   * getApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getApplication  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getApplication", 20, 2, parameters).getVARIANT();
  }

  /**
   * setApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setApplication  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setApplication", 20, 4, parameters);
    return;
  }

  /**
   * getParent. The Parent property returns the parent of the object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getParent  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getParent", 25, 2, parameters).getVARIANT();
  }

  /**
   * setParent. The Parent property returns the parent of the object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setParent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setParent", 25, 4, parameters);
    return;
  }

  /**
   * getSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSession  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSession", 34, 2, parameters).getVARIANT();
  }

  /**
   * setSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSession  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSession", 34, 4, parameters);
    return;
  }

  /**
   * zz_getClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object zz_getClass  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("zz_getClass", 6, 2, parameters).getVARIANT();
  }

  /**
   * setClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setClass  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setClass", 6, 4, parameters);
    return;
  }

  /**
   * getFields. The Fields property returns a single Field object or a Fields collection object. Collectively, the fields that are in this collection specify the filter.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFields  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getFields", 12, 2, parameters).getVARIANT();
  }

  /**
   * setFields. The Fields property returns a single Field object or a Fields collection object. Collectively, the fields that are in this collection specify the filter.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setFields  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setFields", 12, 4, parameters);
    return;
  }

  /**
   * getNot. The Not property specifies that all restriction values are to be negated before being ANDed or ORed to specify the message filter.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getNot  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getNot", 45, 2, parameters).getVARIANT();
  }

  /**
   * setNot. The Not property specifies that all restriction values are to be negated before being ANDed or ORed to specify the message filter.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setNot  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setNot", 45, 4, parameters);
    return;
  }

  /**
   * getOr. The Or property specifies that the restriction values are to be ORed instead of ANDed to specify the message filter.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOr  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getOr", 62, 2, parameters).getVARIANT();
  }

  /**
   * setOr. The Or property specifies that the restriction values are to be ORed instead of ANDed to specify the message filter.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOr  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setOr", 62, 4, parameters);
    return;
  }

  /**
   * getConversation. The Conversation property sets filtering on a message's conversation topic.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getConversation  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getConversation", 8, 2, parameters).getVARIANT();
  }

  /**
   * setConversation. The Conversation property sets filtering on a message's conversation topic.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setConversation  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setConversation", 8, 4, parameters);
    return;
  }

  /**
   * getImportance. The Importance property sets filtering on a message's importance to ActMsgNormal (the default), ActMsgLow, or ActMsgHigh.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getImportance  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getImportance", 27, 2, parameters).getVARIANT();
  }

  /**
   * setImportance. The Importance property sets filtering on a message's importance to ActMsgNormal (the default), ActMsgLow, or ActMsgHigh.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setImportance  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setImportance", 27, 4, parameters);
    return;
  }

  /**
   * getRecipients. The Recipients property sets filtering on whether a message's recipients include a particular Recipient object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getRecipients  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getRecipients", 28, 2, parameters).getVARIANT();
  }

  /**
   * setRecipients. The Recipients property sets filtering on whether a message's recipients include a particular Recipient object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setRecipients  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setRecipients", 28, 4, parameters);
    return;
  }

  /**
   * getSender. The Sender property sets filtering on a message's sender to an AddressEntry object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSender  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSender", 32, 2, parameters).getVARIANT();
  }

  /**
   * setSender. The Sender property sets filtering on a message's sender to an AddressEntry object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSender  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSender", 32, 4, parameters);
    return;
  }

  /**
   * getSent. The Sent property sets filtering on whether or not a message was sent through the messaging system.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSent  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSent", 33, 2, parameters).getVARIANT();
  }

  /**
   * setSent. The Sent property sets filtering on whether or not a message was sent through the messaging system.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSent", 33, 4, parameters);
    return;
  }

  /**
   * getSize. The Size property sets filtering on a message's approximate total size in bytes.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSize  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSize", 36, 2, parameters).getVARIANT();
  }

  /**
   * setSize. The Size property sets filtering on a message's approximate total size in bytes.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSize  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSize", 36, 4, parameters);
    return;
  }

  /**
   * getSubject. The Size property sets filtering on a message's approximate total size in bytes.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSubject  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSubject", 38, 2, parameters).getVARIANT();
  }

  /**
   * setSubject. The Size property sets filtering on a message's approximate total size in bytes.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSubject  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSubject", 38, 4, parameters);
    return;
  }

  /**
   * getText. The Text property sets filtering on a message's main content.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getText  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getText", 39, 2, parameters).getVARIANT();
  }

  /**
   * setText. The Text property sets filtering on a message's main content.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setText  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setText", 39, 4, parameters);
    return;
  }

  /**
   * getTimeFirst. The TimeFirst property sets filtering on whether a message was received at or since the specified date and time.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getTimeFirst  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getTimeFirst", 46, 2, parameters).getVARIANT();
  }

  /**
   * setTimeFirst. The TimeFirst property sets filtering on whether a message was received at or since the specified date and time.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setTimeFirst  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setTimeFirst", 46, 4, parameters);
    return;
  }

  /**
   * getTimeLast. The TimeLast property sets filtering on whether a message was received at or before the specified date and time.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getTimeLast  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getTimeLast", 47, 2, parameters).getVARIANT();
  }

  /**
   * setTimeLast. The TimeLast property sets filtering on whether a message was received at or before the specified date and time.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setTimeLast  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setTimeLast", 47, 4, parameters);
    return;
  }

  /**
   * getType. The Type property sets filtering on a message's message class.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getType  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getType", 17, 2, parameters).getVARIANT();
  }

  /**
   * setType. The Type property sets filtering on a message's message class.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setType  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setType", 17, 4, parameters);
    return;
  }

  /**
   * getUnread. The Unread property sets filtering on whether or not a message has been read.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getUnread  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getUnread", 42, 2, parameters).getVARIANT();
  }

  /**
   * setUnread. The Unread property sets filtering on whether or not a message has been read.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setUnread  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setUnread", 42, 4, parameters);
    return;
  }

  /**
   * isSameAs. The IsSameAs method returns True if the MessageFilter object is the same as the MessageFilter object being compared against.
   *
   * @param     object A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object isSameAs  (
              Object object) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {object == null ? new Variant("object", 0, 0x80020004L) : new Variant("object", 12, object),};
    return invoke("isSameAs", 136, 1, parameters).getVARIANT();
  }

  /** Dummy reference from interface to proxy to make sure proxy gets compiled */
  static final int xxDummy = 0;

  static {
    com.linar.jintegra.InterfaceDesc.add("d725d1c3-7657-101b-acc1-00aa00423326", com.intrinsyc.cdo.MessageFilterProxy.class, null, 0, null );
  }
}
