package com.intrinsyc.cdo;

/**
 * COM Interface 'Messages'. Generated 09-Jan-08 12:10:54 PM
 * from 'C:\Program Files\Common Files\System\MSMAPI\1033\CDO.DLL'<P>
 * Generated using com2java Version 2.8 (c) 2008 Intrinsyc Software International, Inc.  All rights reserved.
 * See  <A HREF="http://j-integra.intrinsyc.com/">http://j-integra.intrinsyc.com/</A><P>
 * Description: '<B>Messages collection</B>'
 *
 * Generator Options:
 *   AwtForOcxs = False
 *   PromptForTypeLibraries = False
 *   RetryOnReject = False
 *   IDispatchOnly = False
 *   GenBeanInfo = False
 *   LowerCaseMemberNames = True
 *   TreatInStarAsIn = False
 *   ArraysAsObjects = False
 *   OmitRestrictedMethods = False
 *   ClashPrefix = zz_
 *   ImplementConflictingInterfaces = False
 *   DontRenameSameMethods = False
 *   RenameConflictingInterfaceMethods = False
 *   ReuseMethods = False
 *
 * Command Line Only Options:
 *   MakeClsidsPublic = False
 *   DontOverwrite = False
 */
public interface Messages extends java.io.Serializable {
  /**
   * getApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getApplication  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setApplication  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getParent. The Parent property returns the parent of the object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getParent  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setParent. The Parent property returns the parent of the object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setParent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSession  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSession  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * zz_getClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object zz_getClass  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setClass  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getRawTable. 
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getRawTable  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setRawTable. 
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setRawTable  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getCount. The Count property returns the number of Message objects in the collection, or a very large number if the exact count is not available.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getCount  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setCount. The Count property returns the number of Message objects in the collection, or a very large number if the exact count is not available.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setCount  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getFilter. The Filter property returns a MessageFilter object for the Messages collection.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFilter  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setFilter. The Filter property returns a MessageFilter object for the Messages collection.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setFilter  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getItem. The Item property returns a single Message object from the Messages collection.
   *
   * @param     index A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getItem  (
              Object index) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * add. The Add method creates and returns a new Message object in the Messages collection.
   *
   * @param     subject A Variant (in, optional, pass null if not required)
   * @param     text A Variant (in, optional, pass null if not required)
   * @param     type A Variant (in, optional, pass null if not required)
   * @param     importance A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object add  (
              Object subject,
              Object text,
              Object type,
              Object importance) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * delete. The Delete method deletes all the messages in the Messages collection.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object delete  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * sort. The Sort method sorts the messages in the collection on the specified property according to the specified sort order.
   *
   * @param     sortOrder A Variant (in, optional, pass null if not required)
   * @param     propID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object sort  (
              Object sortOrder,
              Object propID) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getFirst. The GetFirst method returns the first Message object in the Messages collection. It returns Nothing if no first object exists.
   *
   * @param     filter A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFirst  (
              Object filter) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getNext. The GetNext method returns the next Message object in the Messages collection. It returns Nothing if no next object exists, for example if already positioned at the end of the collection.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getNext  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getLast. The GetLast method returns the last Message object in the Messages collection. It returns Nothing if no last object exists.
   *
   * @param     filter A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getLast  (
              Object filter) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getPrevious. The GetPrevious method returns the previous Message object in the Messages collection. It returns Nothing if no previous object exists, for example if already positioned at the beginning of the collection.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPrevious  () throws java.io.IOException, com.linar.jintegra.AutomationException;


  // Constants to help J-Integra for COM dynamically map DCOM invocations to
  // interface members.  Don't worry, you will never need to explicitly use these constants.
  int IID10eab9e0_68dc_101b_acc1_00aa00423326 = 1;
  /** Dummy reference to interface proxy to make sure it gets compiled */
  int xxDummy = MessagesProxy.xxDummy;
  /** Used internally by J-Integra for COM, please ignore */
  String IID = "00020400-0000-0000-C000-000000000046";
  String DISPID_20_GET_NAME = "getApplication";
  String DISPID_20_PUT_NAME = "setApplication";
  String DISPID_25_GET_NAME = "getParent";
  String DISPID_25_PUT_NAME = "setParent";
  String DISPID_34_GET_NAME = "getSession";
  String DISPID_34_PUT_NAME = "setSession";
  String DISPID_6_GET_NAME = "zz_getClass";
  String DISPID_6_PUT_NAME = "setClass";
  String DISPID_80_GET_NAME = "getRawTable";
  String DISPID_80_PUT_NAME = "setRawTable";
  String DISPID_9_GET_NAME = "getCount";
  String DISPID_9_PUT_NAME = "setCount";
  String DISPID_61_GET_NAME = "getFilter";
  String DISPID_61_PUT_NAME = "setFilter";
  String DISPID_21_GET_NAME = "getItem";
  String DISPID_100_NAME = "add";
  String DISPID_106_NAME = "delete";
  String DISPID_134_NAME = "sort";
  String DISPID_109_NAME = "getFirst";
  String DISPID_111_NAME = "getNext";
  String DISPID_110_NAME = "getLast";
  String DISPID_112_NAME = "getPrevious";
}
