package com.intrinsyc.cdo;

/**
 * COM Interface 'Recipient'. Generated 09-Jan-08 12:10:54 PM
 * from 'C:\Program Files\Common Files\System\MSMAPI\1033\CDO.DLL'<P>
 * Generated using com2java Version 2.8 (c) 2008 Intrinsyc Software International, Inc.  All rights reserved.
 * See  <A HREF="http://j-integra.intrinsyc.com/">http://j-integra.intrinsyc.com/</A><P>
 * Description: '<B>Recipient object</B>'
 *
 * Generator Options:
 *   AwtForOcxs = False
 *   PromptForTypeLibraries = False
 *   RetryOnReject = False
 *   IDispatchOnly = False
 *   GenBeanInfo = False
 *   LowerCaseMemberNames = True
 *   TreatInStarAsIn = False
 *   ArraysAsObjects = False
 *   OmitRestrictedMethods = False
 *   ClashPrefix = zz_
 *   ImplementConflictingInterfaces = False
 *   DontRenameSameMethods = False
 *   RenameConflictingInterfaceMethods = False
 *   ReuseMethods = False
 *
 * Command Line Only Options:
 *   MakeClsidsPublic = False
 *   DontOverwrite = False
 */
public interface Recipient extends java.io.Serializable {
  /**
   * getApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getApplication  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setApplication  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getParent. The Parent property returns the parent of the object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getParent  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setParent. The Parent property returns the parent of the object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setParent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSession  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSession  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * zz_getClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object zz_getClass  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setClass  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getIndex. The Index property returns the index number of the Recipient object within the Recipients collection.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getIndex  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setIndex. The Index property returns the index number of the Recipient object within the Recipients collection.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setIndex  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getDisplayType. The DisplayType property identifies the nature of the recipient.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getDisplayType  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setDisplayType. The DisplayType property identifies the nature of the recipient.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setDisplayType  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getName. The Name property returns or sets the name of the Recipient object as a string.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getName  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setName. The Name property returns or sets the name of the Recipient object as a string.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setName  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getType. The Type property specifies the type of the Recipient object, either To, Cc, or Bcc.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getType  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setType. The Type property specifies the type of the Recipient object, either To, Cc, or Bcc.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setType  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getAddress. The Address property specifies the full address for the recipient.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAddress  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setAddress. The Address property specifies the full address for the recipient.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setAddress  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getID. The ID property returns the unique identifier of this Recipient object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getID  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setID. The ID property returns the unique identifier of this Recipient object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setID  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getMeetingResponseStatus. The MeetingResponseStatus property returns or sets the status of this recipient's response to a meeting request.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMeetingResponseStatus  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setMeetingResponseStatus. The MeetingResponseStatus property returns or sets the status of this recipient's response to a meeting request.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setMeetingResponseStatus  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getAddressEntry. The AddressEntry property contains the AddressEntry object representing the recipient.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAddressEntry  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setAddressEntry. The AddressEntry property contains the AddressEntry object representing the recipient.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setAddressEntry  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getAmbiguousNames. The AmbiguousNames property returns all the ambiguous resolutions for this recipient.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAmbiguousNames  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setAmbiguousNames. The AmbiguousNames property returns all the ambiguous resolutions for this recipient.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setAmbiguousNames  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * delete. The Delete method deletes the Recipient object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object delete  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * resolve. The Resolve method resolves a recipient's address information into a full messaging address.
   *
   * @param     showDialog A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object resolve  (
              Object showDialog) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * isSameAs. The IsSameAs method returns True if the Recipient object is the same as the Recipient object being compared against.
   *
   * @param     object A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object isSameAs  (
              Object object) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getFreeBusy. The GetFreeBusy method returns a string indicating the free/busy status of the user.
   *
   * @param     startTime A Variant (in)
   * @param     endTime A Variant (in)
   * @param     interval A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFreeBusy  (
              Object startTime,
              Object endTime,
              Object interval) throws java.io.IOException, com.linar.jintegra.AutomationException;


  // Constants to help J-Integra for COM dynamically map DCOM invocations to
  // interface members.  Don't worry, you will never need to explicitly use these constants.
  int IID3fa7dead_6438_101b_acc1_00aa00423326 = 1;
  /** Dummy reference to interface proxy to make sure it gets compiled */
  int xxDummy = RecipientProxy.xxDummy;
  /** Used internally by J-Integra for COM, please ignore */
  String IID = "00020400-0000-0000-C000-000000000046";
  String DISPID_20_GET_NAME = "getApplication";
  String DISPID_20_PUT_NAME = "setApplication";
  String DISPID_25_GET_NAME = "getParent";
  String DISPID_25_PUT_NAME = "setParent";
  String DISPID_34_GET_NAME = "getSession";
  String DISPID_34_PUT_NAME = "setSession";
  String DISPID_6_GET_NAME = "zz_getClass";
  String DISPID_6_PUT_NAME = "setClass";
  String DISPID_19_GET_NAME = "getIndex";
  String DISPID_19_PUT_NAME = "setIndex";
  String DISPID_56_GET_NAME = "getDisplayType";
  String DISPID_56_PUT_NAME = "setDisplayType";
  String DISPID_23_GET_NAME = "getName";
  String DISPID_23_PUT_NAME = "setName";
  String DISPID_17_GET_NAME = "getType";
  String DISPID_17_PUT_NAME = "setType";
  String DISPID_2_GET_NAME = "getAddress";
  String DISPID_2_PUT_NAME = "setAddress";
  String DISPID_14_GET_NAME = "getID";
  String DISPID_14_PUT_NAME = "setID";
  String DISPID_325_GET_NAME = "getMeetingResponseStatus";
  String DISPID_325_PUT_NAME = "setMeetingResponseStatus";
  String DISPID_53_GET_NAME = "getAddressEntry";
  String DISPID_53_PUT_NAME = "setAddressEntry";
  String DISPID_81_GET_NAME = "getAmbiguousNames";
  String DISPID_81_PUT_NAME = "setAmbiguousNames";
  String DISPID_106_NAME = "delete";
  String DISPID_130_NAME = "resolve";
  String DISPID_136_NAME = "isSameAs";
  String DISPID_148_NAME = "getFreeBusy";
}
