package com.intrinsyc.cdo;

/**
 * COM Interface 'Recipients'. Generated 09-Jan-08 12:10:54 PM
 * from 'C:\Program Files\Common Files\System\MSMAPI\1033\CDO.DLL'<P>
 * Generated using com2java Version 2.8 (c) 2008 Intrinsyc Software International, Inc.  All rights reserved.
 * See  <A HREF="http://j-integra.intrinsyc.com/">http://j-integra.intrinsyc.com/</A><P>
 * Description: '<B>Recipients collection</B>'
 *
 * Generator Options:
 *   AwtForOcxs = False
 *   PromptForTypeLibraries = False
 *   RetryOnReject = False
 *   IDispatchOnly = False
 *   GenBeanInfo = False
 *   LowerCaseMemberNames = True
 *   TreatInStarAsIn = False
 *   ArraysAsObjects = False
 *   OmitRestrictedMethods = False
 *   ClashPrefix = zz_
 *   ImplementConflictingInterfaces = False
 *   DontRenameSameMethods = False
 *   RenameConflictingInterfaceMethods = False
 *   ReuseMethods = False
 *
 * Command Line Only Options:
 *   MakeClsidsPublic = False
 *   DontOverwrite = False
 */
public interface Recipients extends java.io.Serializable {
  /**
   * getApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getApplication  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setApplication  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getParent. The Parent property returns the parent of the object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getParent  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setParent. The Parent property returns the parent of the object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setParent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSession  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSession  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * zz_getClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object zz_getClass  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setClass  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getCount. The Count property returns the number of Recipient objects in the collection.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getCount  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setCount. The Count property returns the number of Recipient objects in the collection.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setCount  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getResolved. The Resolved property contains True if all of the recipients in the collection have their address information resolved.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getResolved  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setResolved. The Resolved property contains True if all of the recipients in the collection have their address information resolved.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setResolved  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getRawTable. 
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getRawTable  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setRawTable. 
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setRawTable  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getItem. The Item property returns a single Recipient object from the Recipients collection.
   *
   * @param     index A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getItem  (
              Object index) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * add. The Add method creates and returns a new Recipient object in the Recipients collection.
   *
   * @param     name A Variant (in, optional, pass null if not required)
   * @param     address A Variant (in, optional, pass null if not required)
   * @param     type A Variant (in, optional, pass null if not required)
   * @param     entryID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object add  (
              Object name,
              Object address,
              Object type,
              Object entryID) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * addMultiple. The AddMultiple method creates new Recipient objects in the Recipients collection.
   *
   * @param     names A Variant (in)
   * @param     type A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object addMultiple  (
              Object names,
              Object type) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * delete. The Delete method deletes all the recipients in the Recipients collection.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object delete  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * resolve. The Resolve method traverses the Recipients collection to resolve every recipient's address information into a full messaging address.
   *
   * @param     showDialog A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object resolve  (
              Object showDialog) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getFirstUnresolved. The GetFirstUnresolved method returns the first unresolved Recipient in the collection.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFirstUnresolved  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getNextUnresolved. The GetNextUnresolved method returns the next unresolved Recipient in the collection.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getNextUnresolved  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getFreeBusy. The GetFreeBusy method returns a string indicating the free/busy status of the recipients.
   *
   * @param     startTime A Variant (in)
   * @param     endTime A Variant (in)
   * @param     interval A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFreeBusy  (
              Object startTime,
              Object endTime,
              Object interval) throws java.io.IOException, com.linar.jintegra.AutomationException;


  // Constants to help J-Integra for COM dynamically map DCOM invocations to
  // interface members.  Don't worry, you will never need to explicitly use these constants.
  int IIDd725d1c0_7657_101b_acc1_00aa00423326 = 1;
  /** Dummy reference to interface proxy to make sure it gets compiled */
  int xxDummy = RecipientsProxy.xxDummy;
  /** Used internally by J-Integra for COM, please ignore */
  String IID = "00020400-0000-0000-C000-000000000046";
  String DISPID_20_GET_NAME = "getApplication";
  String DISPID_20_PUT_NAME = "setApplication";
  String DISPID_25_GET_NAME = "getParent";
  String DISPID_25_PUT_NAME = "setParent";
  String DISPID_34_GET_NAME = "getSession";
  String DISPID_34_PUT_NAME = "setSession";
  String DISPID_6_GET_NAME = "zz_getClass";
  String DISPID_6_PUT_NAME = "setClass";
  String DISPID_9_GET_NAME = "getCount";
  String DISPID_9_PUT_NAME = "setCount";
  String DISPID_29_GET_NAME = "getResolved";
  String DISPID_29_PUT_NAME = "setResolved";
  String DISPID_80_GET_NAME = "getRawTable";
  String DISPID_80_PUT_NAME = "setRawTable";
  String DISPID_21_GET_NAME = "getItem";
  String DISPID_100_NAME = "add";
  String DISPID_147_NAME = "addMultiple";
  String DISPID_106_NAME = "delete";
  String DISPID_130_NAME = "resolve";
  String DISPID_143_NAME = "getFirstUnresolved";
  String DISPID_144_NAME = "getNextUnresolved";
  String DISPID_148_NAME = "getFreeBusy";
}
