package com.intrinsyc.cdo;

/**
 * COM Interface 'MessageFilter'. Generated 09-Jan-08 12:10:54 PM
 * from 'C:\Program Files\Common Files\System\MSMAPI\1033\CDO.DLL'<P>
 * Generated using com2java Version 2.8 (c) 2008 Intrinsyc Software International, Inc.  All rights reserved.
 * See  <A HREF="http://j-integra.intrinsyc.com/">http://j-integra.intrinsyc.com/</A><P>
 * Description: '<B>MessageFilter object</B>'
 *
 * Generator Options:
 *   AwtForOcxs = False
 *   PromptForTypeLibraries = False
 *   RetryOnReject = False
 *   IDispatchOnly = False
 *   GenBeanInfo = False
 *   LowerCaseMemberNames = True
 *   TreatInStarAsIn = False
 *   ArraysAsObjects = False
 *   OmitRestrictedMethods = False
 *   ClashPrefix = zz_
 *   ImplementConflictingInterfaces = False
 *   DontRenameSameMethods = False
 *   RenameConflictingInterfaceMethods = False
 *   ReuseMethods = False
 *
 * Command Line Only Options:
 *   MakeClsidsPublic = False
 *   DontOverwrite = False
 */
public interface MessageFilter extends java.io.Serializable {
  /**
   * getApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getApplication  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setApplication  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getParent. The Parent property returns the parent of the object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getParent  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setParent. The Parent property returns the parent of the object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setParent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSession  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSession  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * zz_getClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object zz_getClass  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setClass  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getFields. The Fields property returns a single Field object or a Fields collection object. Collectively, the fields that are in this collection specify the filter.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFields  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setFields. The Fields property returns a single Field object or a Fields collection object. Collectively, the fields that are in this collection specify the filter.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setFields  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getNot. The Not property specifies that all restriction values are to be negated before being ANDed or ORed to specify the message filter.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getNot  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setNot. The Not property specifies that all restriction values are to be negated before being ANDed or ORed to specify the message filter.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setNot  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getOr. The Or property specifies that the restriction values are to be ORed instead of ANDed to specify the message filter.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOr  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setOr. The Or property specifies that the restriction values are to be ORed instead of ANDed to specify the message filter.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOr  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getConversation. The Conversation property sets filtering on a message's conversation topic.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getConversation  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setConversation. The Conversation property sets filtering on a message's conversation topic.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setConversation  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getImportance. The Importance property sets filtering on a message's importance to ActMsgNormal (the default), ActMsgLow, or ActMsgHigh.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getImportance  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setImportance. The Importance property sets filtering on a message's importance to ActMsgNormal (the default), ActMsgLow, or ActMsgHigh.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setImportance  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getRecipients. The Recipients property sets filtering on whether a message's recipients include a particular Recipient object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getRecipients  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setRecipients. The Recipients property sets filtering on whether a message's recipients include a particular Recipient object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setRecipients  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSender. The Sender property sets filtering on a message's sender to an AddressEntry object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSender  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSender. The Sender property sets filtering on a message's sender to an AddressEntry object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSender  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSent. The Sent property sets filtering on whether or not a message was sent through the messaging system.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSent  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSent. The Sent property sets filtering on whether or not a message was sent through the messaging system.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSize. The Size property sets filtering on a message's approximate total size in bytes.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSize  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSize. The Size property sets filtering on a message's approximate total size in bytes.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSize  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSubject. The Size property sets filtering on a message's approximate total size in bytes.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSubject  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSubject. The Size property sets filtering on a message's approximate total size in bytes.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSubject  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getText. The Text property sets filtering on a message's main content.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getText  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setText. The Text property sets filtering on a message's main content.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setText  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getTimeFirst. The TimeFirst property sets filtering on whether a message was received at or since the specified date and time.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getTimeFirst  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setTimeFirst. The TimeFirst property sets filtering on whether a message was received at or since the specified date and time.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setTimeFirst  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getTimeLast. The TimeLast property sets filtering on whether a message was received at or before the specified date and time.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getTimeLast  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setTimeLast. The TimeLast property sets filtering on whether a message was received at or before the specified date and time.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setTimeLast  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getType. The Type property sets filtering on a message's message class.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getType  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setType. The Type property sets filtering on a message's message class.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setType  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getUnread. The Unread property sets filtering on whether or not a message has been read.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getUnread  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setUnread. The Unread property sets filtering on whether or not a message has been read.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setUnread  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * isSameAs. The IsSameAs method returns True if the MessageFilter object is the same as the MessageFilter object being compared against.
   *
   * @param     object A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object isSameAs  (
              Object object) throws java.io.IOException, com.linar.jintegra.AutomationException;


  // Constants to help J-Integra for COM dynamically map DCOM invocations to
  // interface members.  Don't worry, you will never need to explicitly use these constants.
  int IIDd725d1c3_7657_101b_acc1_00aa00423326 = 1;
  /** Dummy reference to interface proxy to make sure it gets compiled */
  int xxDummy = MessageFilterProxy.xxDummy;
  /** Used internally by J-Integra for COM, please ignore */
  String IID = "00020400-0000-0000-C000-000000000046";
  String DISPID_20_GET_NAME = "getApplication";
  String DISPID_20_PUT_NAME = "setApplication";
  String DISPID_25_GET_NAME = "getParent";
  String DISPID_25_PUT_NAME = "setParent";
  String DISPID_34_GET_NAME = "getSession";
  String DISPID_34_PUT_NAME = "setSession";
  String DISPID_6_GET_NAME = "zz_getClass";
  String DISPID_6_PUT_NAME = "setClass";
  String DISPID_12_GET_NAME = "getFields";
  String DISPID_12_PUT_NAME = "setFields";
  String DISPID_45_GET_NAME = "getNot";
  String DISPID_45_PUT_NAME = "setNot";
  String DISPID_62_GET_NAME = "getOr";
  String DISPID_62_PUT_NAME = "setOr";
  String DISPID_8_GET_NAME = "getConversation";
  String DISPID_8_PUT_NAME = "setConversation";
  String DISPID_27_GET_NAME = "getImportance";
  String DISPID_27_PUT_NAME = "setImportance";
  String DISPID_28_GET_NAME = "getRecipients";
  String DISPID_28_PUT_NAME = "setRecipients";
  String DISPID_32_GET_NAME = "getSender";
  String DISPID_32_PUT_NAME = "setSender";
  String DISPID_33_GET_NAME = "getSent";
  String DISPID_33_PUT_NAME = "setSent";
  String DISPID_36_GET_NAME = "getSize";
  String DISPID_36_PUT_NAME = "setSize";
  String DISPID_38_GET_NAME = "getSubject";
  String DISPID_38_PUT_NAME = "setSubject";
  String DISPID_39_GET_NAME = "getText";
  String DISPID_39_PUT_NAME = "setText";
  String DISPID_46_GET_NAME = "getTimeFirst";
  String DISPID_46_PUT_NAME = "setTimeFirst";
  String DISPID_47_GET_NAME = "getTimeLast";
  String DISPID_47_PUT_NAME = "setTimeLast";
  String DISPID_17_GET_NAME = "getType";
  String DISPID_17_PUT_NAME = "setType";
  String DISPID_42_GET_NAME = "getUnread";
  String DISPID_42_PUT_NAME = "setUnread";
  String DISPID_136_NAME = "isSameAs";
}
