package com.intrinsyc.cdo;

/**
 * COM Interface 'RecurrencePattern'. Generated 09-Jan-08 12:10:54 PM
 * from 'C:\Program Files\Common Files\System\MSMAPI\1033\CDO.DLL'<P>
 * Generated using com2java Version 2.8 (c) 2008 Intrinsyc Software International, Inc.  All rights reserved.
 * See  <A HREF="http://j-integra.intrinsyc.com/">http://j-integra.intrinsyc.com/</A><P>
 * Description: '<B>RecurrencePattern object</B>'
 *
 * Generator Options:
 *   AwtForOcxs = False
 *   PromptForTypeLibraries = False
 *   RetryOnReject = False
 *   IDispatchOnly = False
 *   GenBeanInfo = False
 *   LowerCaseMemberNames = True
 *   TreatInStarAsIn = False
 *   ArraysAsObjects = False
 *   OmitRestrictedMethods = False
 *   ClashPrefix = zz_
 *   ImplementConflictingInterfaces = False
 *   DontRenameSameMethods = False
 *   RenameConflictingInterfaceMethods = False
 *   ReuseMethods = False
 *
 * Command Line Only Options:
 *   MakeClsidsPublic = False
 *   DontOverwrite = False
 */
public interface RecurrencePattern extends java.io.Serializable {
  /**
   * getApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getApplication  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setApplication  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getParent. The Parent property returns the parent of the object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getParent  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setParent. The Parent property returns the parent of the object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setParent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSession  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSession  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * zz_getClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object zz_getClass  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setClass  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getDayOfMonth. The DayOfMonth property returns or sets the day of the month on which the appointment recurs.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getDayOfMonth  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setDayOfMonth. The DayOfMonth property returns or sets the day of the month on which the appointment recurs.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setDayOfMonth  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getDayOfWeekMask. The DayOfWeekMask property returns or sets the mask for the days of the week on which the appointment recurs.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getDayOfWeekMask  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setDayOfWeekMask. The DayOfWeekMask property returns or sets the mask for the days of the week on which the appointment recurs.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setDayOfWeekMask  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getDuration. The Duration property returns the duration of the recurring appointment in minutes.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getDuration  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setDuration. The Duration property returns the duration of the recurring appointment in minutes.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setDuration  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getEndTime. The EndTime property returns or sets the ending time for each recurrence of the appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getEndTime  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setEndTime. The EndTime property returns or sets the ending time for each recurrence of the appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setEndTime  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getStartTime. The StartTime property returns or sets the starting time for each recurrence of the appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getStartTime  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setStartTime. The StartTime property returns or sets the starting time for each recurrence of the appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setStartTime  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getInstance. The Instance property returns or sets the instance of the day within the month on which the appointment recurs.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getInstance  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setInstance. The Instance property returns or sets the instance of the day within the month on which the appointment recurs.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setInstance  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getInterval. The Interval property returns or sets the number of recurrence units between recurrences of the appointment.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getInterval  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setInterval. The Interval property returns or sets the number of recurrence units between recurrences of the appointment.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setInterval  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getMonthOfYear. The MonthOfYear property returns or sets the month of the year in which the appointment recurs.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMonthOfYear  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setMonthOfYear. The MonthOfYear property returns or sets the month of the year in which the appointment recurs.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setMonthOfYear  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getNoEndDate. The NoEndDate property indicates whether the recurrence pattern has an ending date.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getNoEndDate  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setNoEndDate. The NoEndDate property indicates whether the recurrence pattern has an ending date.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setNoEndDate  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getOccurrences. The Occurrences property returns or sets the number of occurrences of the recurrence pattern.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOccurrences  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setOccurrences. The Occurrences property returns or sets the number of occurrences of the recurrence pattern.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOccurrences  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getPatternEndDate. The PatternEndDate property returns or sets the day on or before which the appointment last recurs.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPatternEndDate  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setPatternEndDate. The PatternEndDate property returns or sets the day on or before which the appointment last recurs.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setPatternEndDate  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getPatternStartDate. The PatternStartDate property returns or sets the day on or after which the appointment first recurs.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPatternStartDate  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setPatternStartDate. The PatternStartDate property returns or sets the day on or after which the appointment first recurs.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setPatternStartDate  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getRecurrenceType. The RecurrenceType property returns or sets the recurrence unit and the frequency with which the appointment recurs.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getRecurrenceType  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setRecurrenceType. The RecurrenceType property returns or sets the recurrence unit and the frequency with which the appointment recurs.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setRecurrenceType  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;


  // Constants to help J-Integra for COM dynamically map DCOM invocations to
  // interface members.  Don't worry, you will never need to explicitly use these constants.
  int IIDef9203e9_b9a5_101b_acc1_00aa00423326 = 1;
  /** Dummy reference to interface proxy to make sure it gets compiled */
  int xxDummy = RecurrencePatternProxy.xxDummy;
  /** Used internally by J-Integra for COM, please ignore */
  String IID = "00020400-0000-0000-C000-000000000046";
  String DISPID_20_GET_NAME = "getApplication";
  String DISPID_20_PUT_NAME = "setApplication";
  String DISPID_25_GET_NAME = "getParent";
  String DISPID_25_PUT_NAME = "setParent";
  String DISPID_34_GET_NAME = "getSession";
  String DISPID_34_PUT_NAME = "setSession";
  String DISPID_6_GET_NAME = "zz_getClass";
  String DISPID_6_PUT_NAME = "setClass";
  String DISPID_316_GET_NAME = "getDayOfMonth";
  String DISPID_316_PUT_NAME = "setDayOfMonth";
  String DISPID_317_GET_NAME = "getDayOfWeekMask";
  String DISPID_317_PUT_NAME = "setDayOfWeekMask";
  String DISPID_304_GET_NAME = "getDuration";
  String DISPID_304_PUT_NAME = "setDuration";
  String DISPID_89_GET_NAME = "getEndTime";
  String DISPID_89_PUT_NAME = "setEndTime";
  String DISPID_88_GET_NAME = "getStartTime";
  String DISPID_88_PUT_NAME = "setStartTime";
  String DISPID_318_GET_NAME = "getInstance";
  String DISPID_318_PUT_NAME = "setInstance";
  String DISPID_90_GET_NAME = "getInterval";
  String DISPID_90_PUT_NAME = "setInterval";
  String DISPID_319_GET_NAME = "getMonthOfYear";
  String DISPID_319_PUT_NAME = "setMonthOfYear";
  String DISPID_320_GET_NAME = "getNoEndDate";
  String DISPID_320_PUT_NAME = "setNoEndDate";
  String DISPID_321_GET_NAME = "getOccurrences";
  String DISPID_321_PUT_NAME = "setOccurrences";
  String DISPID_322_GET_NAME = "getPatternEndDate";
  String DISPID_322_PUT_NAME = "setPatternEndDate";
  String DISPID_323_GET_NAME = "getPatternStartDate";
  String DISPID_323_PUT_NAME = "setPatternStartDate";
  String DISPID_324_GET_NAME = "getRecurrenceType";
  String DISPID_324_PUT_NAME = "setRecurrenceType";
}
