package com.intrinsyc.cdo;

import com.linar.jintegra.*;

/**
 * COM Class 'Session'. Generated 09-Jan-08 12:10:54 PM
 * from 'C:\Program Files\Common Files\System\MSMAPI\1033\CDO.DLL'<P>
 * Generated using com2java Version 2.8 (c) 2008 Intrinsyc Software International, Inc.  All rights reserved.
 * See  <A HREF="http://j-integra.intrinsyc.com/">http://j-integra.intrinsyc.com/</A><P>
 *
 * Generator Options:
 *   AwtForOcxs = False
 *   PromptForTypeLibraries = False
 *   RetryOnReject = False
 *   IDispatchOnly = False
 *   GenBeanInfo = False
 *   LowerCaseMemberNames = True
 *   TreatInStarAsIn = False
 *   ArraysAsObjects = False
 *   OmitRestrictedMethods = False
 *   ClashPrefix = zz_
 *   ImplementConflictingInterfaces = False
 *   DontRenameSameMethods = False
 *   RenameConflictingInterfaceMethods = False
 *   ReuseMethods = False
 *
 * Command Line Only Options:
 *   MakeClsidsPublic = False
 *   DontOverwrite = False
 */
public class Session implements com.linar.jintegra.RemoteObjRef, com.intrinsyc.cdo._Session {

  private static final String CLSID = "3fa7deb3-6438-101b-acc1-00aa00423326";

  protected String getJintegraVersion() { return "2.8"; }

  // Interface delegates
  private com.intrinsyc.cdo._SessionProxy d__SessionProxy = null;

  /** Access this COM class's com.intrinsyc.cdo._Session interface */
  public com.intrinsyc.cdo._Session getAs_Session() { return d__SessionProxy; }

  /** Compare this object with another */
  public boolean equals(Object o) { 
	if(java.beans.Beans.isDesignTime()) return super.equals(o);
	else return getJintegraDispatch() == null ? false : getJintegraDispatch().equals(o);
  }


  /** the hashcode for this object */
  public int hashCode() { return getJintegraDispatch() == null ? 0 : getJintegraDispatch().hashCode(); }

   /**
   * getActiveObject. Get a reference to a running instance of this class on the current machine using native code.
   *                  <B>Uses native code (See GetActiveObject() in MS doc) and thus can only be used on MS Windows</B>
   *
   * @return    A reference to the running object.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If there was an error attaching to the instance.
   */
  public static Session getActiveObject() throws com.linar.jintegra.AutomationException, java.io.IOException {
    return new Session(com.linar.jintegra.Dispatch.getActiveObject(CLSID));
  }

  /**
   * bindUsingMoniker. Bind to a running instance of this class using the supplied ObjRef moniker
   *
   * @return    A reference to the running object.
   * @param     moniker The ObjRef Moniker (Created using Windows CreateObjrefMoniker() and IMoniker->GetDisplayName).
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If there was an error attaching to the instance.
   */
  public static Session bindUsingMoniker(String moniker) throws com.linar.jintegra.AutomationException, java.io.IOException {
    return new Session(com.linar.jintegra.Dispatch.bindUsingMoniker(moniker));
  }

  /** J-Integra for COM internal method */
  public com.linar.jintegra.Dispatch getJintegraDispatch() {  return d__SessionProxy; }

  /**
   * Constructs a Session on the local host.
   * @exception java.io.IOException if there are problems communicating via DCOM 
   * @exception java.net.UnknownHostException if the host can not be found 
   */
  public Session() throws java.io.IOException, java.net.UnknownHostException {
    this("localhost");
  }

  /**
   * Construct a Session on specified host.
   * @param     host  the host on which the object should be created
   * @exception java.io.IOException if there are problems communicating via DCOM 
   * @exception java.net.UnknownHostException if the host can not be found 
   */
  public Session(String host) throws java.io.IOException, java.net.UnknownHostException {
    d__SessionProxy = new com.intrinsyc.cdo._SessionProxy(CLSID, host, null);
  }

  /**
   * Construct a Session using a reference to such an object returned from a COM server
   * @param     obj an object returned from a COM server
   * @exception java.io.IOException if there are problems communicating via DCOM 
   */
  public Session(Object obj) throws java.io.IOException {
    d__SessionProxy = new com.intrinsyc.cdo._SessionProxy(obj);
  }

  /**
   * Release a Session.
   */
  public void release() {
    com.linar.jintegra.Cleaner.release(d__SessionProxy);
  }

  /**
   * getPropertyByName. Get the value of a property dynamically at run-time, based on its name
   *
   * @return    The value of the property.
   * @param     name The name of the property to get.
   * @exception java.lang.NoSuchFieldException If the property does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPropertyByName(String name) throws NoSuchFieldException, java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getPropertyByName(name);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    } catch(NoSuchFieldException noSuchFieldException) {
      noSuchFieldException.fillInStackTrace();
      throw noSuchFieldException;
    }
  }

  /**
   * getPropertyByName. Get the value of a property dynamically at run-time, based on its name and a parameter
   *
   * @return    The value of the property.
   * @param     name The name of the property to get.
   * @param     rhs A parameter used when getting the proxy.
   * @exception java.lang.NoSuchFieldException If the property does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPropertyByName(String name, Object rhs) throws NoSuchFieldException, java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getPropertyByName(name, rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    } catch(NoSuchFieldException noSuchFieldException) {
      noSuchFieldException.fillInStackTrace();
      throw noSuchFieldException;
    }
  }

  /**
   * invokeMethodByName. Invoke a method dynamically at run-time
   *
   * @return    The value returned by the method (null if none).
   * @param     name The name of the method to be invoked.
   * @param     parameters One element for each parameter. Use primitive type wrappers.
   *            to pass primitive types (eg Integer to pass an int).
   * @exception java.lang.NoSuchMethodException If the method does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object invokeMethodByName(String name, Object[] parameters) throws NoSuchMethodException, java.io.IOException, com.linar.jintegra.AutomationException {
    return d__SessionProxy.invokeMethodByName(name, parameters);
  }

  /**
   * invokeMethodByName. Invoke a method dynamically at run-time
   *
   * @return    The value returned by the method (null if none).
   * @param     name The name of the method to be invoked.
   * @exception java.lang.NoSuchMethodException If the method does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object invokeMethodByName(String name) throws NoSuchMethodException, java.io.IOException, com.linar.jintegra.AutomationException {
    return d__SessionProxy.invokeMethodByName(name, new Object[]{});
  }

  /**
   * getApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getApplication  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getApplication();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setApplication  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      d__SessionProxy.setApplication(rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getParent. The Parent property returns the parent of the object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getParent  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getParent();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setParent. The Parent property returns the parent of the object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setParent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      d__SessionProxy.setParent(rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSession  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getSession();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSession  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      d__SessionProxy.setSession(rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * zz_getClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object zz_getClass  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.zz_getClass();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setClass  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      d__SessionProxy.setClass(rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getMAPIOBJECT. 
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMAPIOBJECT  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getMAPIOBJECT();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setMAPIOBJECT. 
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setMAPIOBJECT  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      d__SessionProxy.setMAPIOBJECT(rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getVersion. The Version property returns the version number of the CDO Library.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getVersion  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getVersion();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setVersion. The Version property returns the version number of the CDO Library.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setVersion  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      d__SessionProxy.setVersion(rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getOperatingSystem. The OperatingSystem property returns the name and version number of the current operating system.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOperatingSystem  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getOperatingSystem();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setOperatingSystem. The OperatingSystem property returns the name and version number of the current operating system.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOperatingSystem  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      d__SessionProxy.setOperatingSystem(rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getName. The Name property returns the display name of the profile logged on to this session.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getName  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getName();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setName. The Name property returns the display name of the profile logged on to this session.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setName  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      d__SessionProxy.setName(rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getCurrentUser. The CurrentUser property returns the active user as an AddressEntry object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getCurrentUser  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getCurrentUser();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setCurrentUser. The CurrentUser property returns the active user as an AddressEntry object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setCurrentUser  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      d__SessionProxy.setCurrentUser(rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getInbox. The Inbox property returns a Folder object representing the current user's Inbox folder.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getInbox  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getInbox();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setInbox. The Inbox property returns a Folder object representing the current user's Inbox folder.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setInbox  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      d__SessionProxy.setInbox(rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getOutbox. The Outbox property returns a Folder object representing the current user's Outbox folder.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOutbox  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getOutbox();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setOutbox. The Outbox property returns a Folder object representing the current user's Outbox folder.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOutbox  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      d__SessionProxy.setOutbox(rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getInfoStores. The InfoStores property returns an InfoStores collection available to this session.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getInfoStores  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getInfoStores();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setInfoStores. The InfoStores property returns an InfoStores collection available to this session.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setInfoStores  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      d__SessionProxy.setInfoStores(rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getAddressLists. The AddressLists property returns a single AddressList object or an AddressLists collection object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAddressLists  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getAddressLists();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setAddressLists. The AddressLists property returns a single AddressList object or an AddressLists collection object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setAddressLists  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      d__SessionProxy.setAddressLists(rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getOutOfOffice. The OutofOffice property indicates whether the user is currently considered out of the office.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOutOfOffice  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getOutOfOffice();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setOutOfOffice. The OutofOffice property indicates whether the user is currently considered out of the office.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOutOfOffice  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      d__SessionProxy.setOutOfOffice(rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getOutOfOfficeText. The OutOfOfficeText property is the text of the message others receive if they send mail to this user while the user is out of the office.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOutOfOfficeText  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getOutOfOfficeText();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setOutOfOfficeText. The OutOfOfficeText property is the text of the message others receive if they send mail to this user while the user is out of the office.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOutOfOfficeText  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      d__SessionProxy.setOutOfOfficeText(rhs);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * logon. The Logon method logs on to the messaging system.
   *
   * @param     profileName A Variant (in, optional, pass null if not required)
   * @param     profilePassword A Variant (in, optional, pass null if not required)
   * @param     showDialog A Variant (in, optional, pass null if not required)
   * @param     newSession A Variant (in, optional, pass null if not required)
   * @param     parentWindow A Variant (in, optional, pass null if not required)
   * @param     noMail A Variant (in, optional, pass null if not required)
   * @param     profileInfo A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object logon  (
              Object profileName,
              Object profilePassword,
              Object showDialog,
              Object newSession,
              Object parentWindow,
              Object noMail,
              Object profileInfo) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.logon(profileName,profilePassword,showDialog,newSession,parentWindow,noMail,profileInfo);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * logoff. The Logoff method logs off from the messaging system.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object logoff  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.logoff();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getInfoStore. The GetInfoStore method returns an InfoStore object that can be used to navigate through both public folders and the user's personal folders.
   *
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getInfoStore  (
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getInfoStore(storeID);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getFolder. The GetFolder method returns a Folder object from a message store.
   *
   * @param     folderID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFolder  (
              Object folderID,
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getFolder(folderID,storeID);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getMessage. The GetMessage method returns a Message object from a message store.
   *
   * @param     messageID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMessage  (
              Object messageID,
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getMessage(messageID,storeID);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getArticle. The GetArticle method returns a Message object from a message store based on its article ID.
   *
   * @param     articleID A Variant (in)
   * @param     folderID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getArticle  (
              Object articleID,
              Object folderID,
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getArticle(articleID,folderID,storeID);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getAddressEntry. The GetAddressEntry method returns an AddressEntry object.
   *
   * @param     entryID A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAddressEntry  (
              Object entryID) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getAddressEntry(entryID);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * addressBook. The AddressBook method displays a modal dialog box that allows the user to select entries from the address book. The selections are returned in a Recipients collection object.
   *
   * @param     recipients A Variant (in, optional, pass null if not required)
   * @param     title A Variant (in, optional, pass null if not required)
   * @param     oneAddress A Variant (in, optional, pass null if not required)
   * @param     forceResolution A Variant (in, optional, pass null if not required)
   * @param     recipLists A Variant (in, optional, pass null if not required)
   * @param     toLabel A Variant (in, optional, pass null if not required)
   * @param     ccLabel A Variant (in, optional, pass null if not required)
   * @param     bccLabel A Variant (in, optional, pass null if not required)
   * @param     parentWindow A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object addressBook  (
              Object recipients,
              Object title,
              Object oneAddress,
              Object forceResolution,
              Object recipLists,
              Object toLabel,
              Object ccLabel,
              Object bccLabel,
              Object parentWindow) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.addressBook(recipients,title,oneAddress,forceResolution,recipLists,toLabel,ccLabel,bccLabel,parentWindow);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * deliverNow. The DeliverNow method requests immediate delivery of all undelivered messages submitted in the current session.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object deliverNow  () throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.deliverNow();
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * compareIDs. The CompareIDs method determines whether two CDO Library objects are the same object.
   *
   * @param     iD1 A Variant (in)
   * @param     iD2 A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object compareIDs  (
              Object iD1,
              Object iD2) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.compareIDs(iD1,iD2);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * createConversationIndex. The CreateConversationIndex method creates a new conversation index or a child conversation index based on a parent conversation index.
   *
   * @param     parentIndex A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object createConversationIndex  (
              Object parentIndex) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.createConversationIndex(parentIndex);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setLocaleIDs. The SetLocaleIDs method sets the Locale, Sort Locale, and Codepage IDs for the current session.
   *
   * @param     localeID A Variant (in)
   * @param     codePageID A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object setLocaleIDs  (
              Object localeID,
              Object codePageID) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.setLocaleIDs(localeID,codePageID);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getDefaultFolder. The GetDefaultFolder method returns the default folder of the specified type.
   *
   * @param     objectType A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getDefaultFolder  (
              Object objectType) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getDefaultFolder(objectType);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getAddressList. The GetAddressList method returns the default address list of the specified type.
   *
   * @param     objectType A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAddressList  (
              Object objectType) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getAddressList(objectType);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * getOption. The GetOption method returns a user preference.
   *
   * @param     optType A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOption  (
              Object optType) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.getOption(optType);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

  /**
   * setOption. The SetOption method sets a user preference.
   *
   * @param     optType A Variant (in)
   * @param     optValue A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object setOption  (
              Object optType,
              Object optValue) throws java.io.IOException, com.linar.jintegra.AutomationException {
    try {
      return d__SessionProxy.setOption(optType,optValue);
    } catch(com.linar.jintegra.AutomationException automationException) {
      automationException.fillInStackTrace();
      throw automationException;
    }
  }

}
