package com.intrinsyc.cdo;

/**
 * COM Interface '_Session'. Generated 09-Jan-08 12:10:54 PM
 * from 'C:\Program Files\Common Files\System\MSMAPI\1033\CDO.DLL'<P>
 * Generated using com2java Version 2.8 (c) 2008 Intrinsyc Software International, Inc.  All rights reserved.
 * See  <A HREF="http://j-integra.intrinsyc.com/">http://j-integra.intrinsyc.com/</A><P>
 * Description: '<B>CDO Session</B>'
 *
 * Generator Options:
 *   AwtForOcxs = False
 *   PromptForTypeLibraries = False
 *   RetryOnReject = False
 *   IDispatchOnly = False
 *   GenBeanInfo = False
 *   LowerCaseMemberNames = True
 *   TreatInStarAsIn = False
 *   ArraysAsObjects = False
 *   OmitRestrictedMethods = False
 *   ClashPrefix = zz_
 *   ImplementConflictingInterfaces = False
 *   DontRenameSameMethods = False
 *   RenameConflictingInterfaceMethods = False
 *   ReuseMethods = False
 *
 * Command Line Only Options:
 *   MakeClsidsPublic = False
 *   DontOverwrite = False
 */
public interface _Session extends java.io.Serializable {
  /**
   * getApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getApplication  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setApplication  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getParent. The Parent property returns the parent of the object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getParent  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setParent. The Parent property returns the parent of the object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setParent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSession  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSession  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * zz_getClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object zz_getClass  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setClass  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getMAPIOBJECT. 
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMAPIOBJECT  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setMAPIOBJECT. 
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setMAPIOBJECT  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getVersion. The Version property returns the version number of the CDO Library.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getVersion  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setVersion. The Version property returns the version number of the CDO Library.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setVersion  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getOperatingSystem. The OperatingSystem property returns the name and version number of the current operating system.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOperatingSystem  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setOperatingSystem. The OperatingSystem property returns the name and version number of the current operating system.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOperatingSystem  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getName. The Name property returns the display name of the profile logged on to this session.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getName  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setName. The Name property returns the display name of the profile logged on to this session.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setName  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getCurrentUser. The CurrentUser property returns the active user as an AddressEntry object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getCurrentUser  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setCurrentUser. The CurrentUser property returns the active user as an AddressEntry object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setCurrentUser  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getInbox. The Inbox property returns a Folder object representing the current user's Inbox folder.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getInbox  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setInbox. The Inbox property returns a Folder object representing the current user's Inbox folder.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setInbox  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getOutbox. The Outbox property returns a Folder object representing the current user's Outbox folder.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOutbox  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setOutbox. The Outbox property returns a Folder object representing the current user's Outbox folder.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOutbox  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getInfoStores. The InfoStores property returns an InfoStores collection available to this session.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getInfoStores  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setInfoStores. The InfoStores property returns an InfoStores collection available to this session.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setInfoStores  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getAddressLists. The AddressLists property returns a single AddressList object or an AddressLists collection object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAddressLists  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setAddressLists. The AddressLists property returns a single AddressList object or an AddressLists collection object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setAddressLists  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getOutOfOffice. The OutofOffice property indicates whether the user is currently considered out of the office.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOutOfOffice  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setOutOfOffice. The OutofOffice property indicates whether the user is currently considered out of the office.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOutOfOffice  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getOutOfOfficeText. The OutOfOfficeText property is the text of the message others receive if they send mail to this user while the user is out of the office.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOutOfOfficeText  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setOutOfOfficeText. The OutOfOfficeText property is the text of the message others receive if they send mail to this user while the user is out of the office.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOutOfOfficeText  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * logon. The Logon method logs on to the messaging system.
   *
   * @param     profileName A Variant (in, optional, pass null if not required)
   * @param     profilePassword A Variant (in, optional, pass null if not required)
   * @param     showDialog A Variant (in, optional, pass null if not required)
   * @param     newSession A Variant (in, optional, pass null if not required)
   * @param     parentWindow A Variant (in, optional, pass null if not required)
   * @param     noMail A Variant (in, optional, pass null if not required)
   * @param     profileInfo A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object logon  (
              Object profileName,
              Object profilePassword,
              Object showDialog,
              Object newSession,
              Object parentWindow,
              Object noMail,
              Object profileInfo) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * logoff. The Logoff method logs off from the messaging system.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object logoff  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getInfoStore. The GetInfoStore method returns an InfoStore object that can be used to navigate through both public folders and the user's personal folders.
   *
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getInfoStore  (
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getFolder. The GetFolder method returns a Folder object from a message store.
   *
   * @param     folderID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFolder  (
              Object folderID,
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getMessage. The GetMessage method returns a Message object from a message store.
   *
   * @param     messageID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMessage  (
              Object messageID,
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getArticle. The GetArticle method returns a Message object from a message store based on its article ID.
   *
   * @param     articleID A Variant (in)
   * @param     folderID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getArticle  (
              Object articleID,
              Object folderID,
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getAddressEntry. The GetAddressEntry method returns an AddressEntry object.
   *
   * @param     entryID A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAddressEntry  (
              Object entryID) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * addressBook. The AddressBook method displays a modal dialog box that allows the user to select entries from the address book. The selections are returned in a Recipients collection object.
   *
   * @param     recipients A Variant (in, optional, pass null if not required)
   * @param     title A Variant (in, optional, pass null if not required)
   * @param     oneAddress A Variant (in, optional, pass null if not required)
   * @param     forceResolution A Variant (in, optional, pass null if not required)
   * @param     recipLists A Variant (in, optional, pass null if not required)
   * @param     toLabel A Variant (in, optional, pass null if not required)
   * @param     ccLabel A Variant (in, optional, pass null if not required)
   * @param     bccLabel A Variant (in, optional, pass null if not required)
   * @param     parentWindow A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object addressBook  (
              Object recipients,
              Object title,
              Object oneAddress,
              Object forceResolution,
              Object recipLists,
              Object toLabel,
              Object ccLabel,
              Object bccLabel,
              Object parentWindow) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * deliverNow. The DeliverNow method requests immediate delivery of all undelivered messages submitted in the current session.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object deliverNow  () throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * compareIDs. The CompareIDs method determines whether two CDO Library objects are the same object.
   *
   * @param     iD1 A Variant (in)
   * @param     iD2 A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object compareIDs  (
              Object iD1,
              Object iD2) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * createConversationIndex. The CreateConversationIndex method creates a new conversation index or a child conversation index based on a parent conversation index.
   *
   * @param     parentIndex A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object createConversationIndex  (
              Object parentIndex) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setLocaleIDs. The SetLocaleIDs method sets the Locale, Sort Locale, and Codepage IDs for the current session.
   *
   * @param     localeID A Variant (in)
   * @param     codePageID A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object setLocaleIDs  (
              Object localeID,
              Object codePageID) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getDefaultFolder. The GetDefaultFolder method returns the default folder of the specified type.
   *
   * @param     objectType A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getDefaultFolder  (
              Object objectType) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getAddressList. The GetAddressList method returns the default address list of the specified type.
   *
   * @param     objectType A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAddressList  (
              Object objectType) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * getOption. The GetOption method returns a user preference.
   *
   * @param     optType A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOption  (
              Object optType) throws java.io.IOException, com.linar.jintegra.AutomationException;

  /**
   * setOption. The SetOption method sets a user preference.
   *
   * @param     optType A Variant (in)
   * @param     optValue A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object setOption  (
              Object optType,
              Object optValue) throws java.io.IOException, com.linar.jintegra.AutomationException;


  // Constants to help J-Integra for COM dynamically map DCOM invocations to
  // interface members.  Don't worry, you will never need to explicitly use these constants.
  int IID3fa7dea8_6438_101b_acc1_00aa00423326 = 1;
  /** Dummy reference to interface proxy to make sure it gets compiled */
  int xxDummy = _SessionProxy.xxDummy;
  /** Used internally by J-Integra for COM, please ignore */
  String IID = "00020400-0000-0000-C000-000000000046";
  String DISPID_20_GET_NAME = "getApplication";
  String DISPID_20_PUT_NAME = "setApplication";
  String DISPID_25_GET_NAME = "getParent";
  String DISPID_25_PUT_NAME = "setParent";
  String DISPID_34_GET_NAME = "getSession";
  String DISPID_34_PUT_NAME = "setSession";
  String DISPID_6_GET_NAME = "zz_getClass";
  String DISPID_6_PUT_NAME = "setClass";
  String DISPID_49_GET_NAME = "getMAPIOBJECT";
  String DISPID_49_PUT_NAME = "setMAPIOBJECT";
  String DISPID_44_GET_NAME = "getVersion";
  String DISPID_44_PUT_NAME = "setVersion";
  String DISPID_24_GET_NAME = "getOperatingSystem";
  String DISPID_24_PUT_NAME = "setOperatingSystem";
  String DISPID_23_GET_NAME = "getName";
  String DISPID_23_PUT_NAME = "setName";
  String DISPID_1_GET_NAME = "getCurrentUser";
  String DISPID_1_PUT_NAME = "setCurrentUser";
  String DISPID_15_GET_NAME = "getInbox";
  String DISPID_15_PUT_NAME = "setInbox";
  String DISPID_16_GET_NAME = "getOutbox";
  String DISPID_16_PUT_NAME = "setOutbox";
  String DISPID_57_GET_NAME = "getInfoStores";
  String DISPID_57_PUT_NAME = "setInfoStores";
  String DISPID_4_GET_NAME = "getAddressLists";
  String DISPID_4_PUT_NAME = "setAddressLists";
  String DISPID_82_GET_NAME = "getOutOfOffice";
  String DISPID_82_PUT_NAME = "setOutOfOffice";
  String DISPID_83_GET_NAME = "getOutOfOfficeText";
  String DISPID_83_PUT_NAME = "setOutOfOfficeText";
  String DISPID_119_NAME = "logon";
  String DISPID_118_NAME = "logoff";
  String DISPID_122_NAME = "getInfoStore";
  String DISPID_116_NAME = "getFolder";
  String DISPID_117_NAME = "getMessage";
  String DISPID_158_NAME = "getArticle";
  String DISPID_114_NAME = "getAddressEntry";
  String DISPID_101_NAME = "addressBook";
  String DISPID_108_NAME = "deliverNow";
  String DISPID_137_NAME = "compareIDs";
  String DISPID_146_NAME = "createConversationIndex";
  String DISPID_145_NAME = "setLocaleIDs";
  String DISPID_153_NAME = "getDefaultFolder";
  String DISPID_155_NAME = "getAddressList";
  String DISPID_156_NAME = "getOption";
  String DISPID_157_NAME = "setOption";
}
