package com.intrinsyc.cdo;

import com.linar.jintegra.*;
/**
 * Proxy for COM Interface '_Session'. Generated 09-Jan-08 12:10:54 PM
 * from 'C:\Program Files\Common Files\System\MSMAPI\1033\CDO.DLL'<P>
 * Generated using com2java Version 2.8 (c) 2008 Intrinsyc Software International, Inc.  All rights reserved.
 * See  <A HREF="http://j-integra.intrinsyc.com/">http://j-integra.intrinsyc.com/</A><P>
 * Description: '<B>CDO Session</B>'
 *
 * Generator Options:
 *   AwtForOcxs = False
 *   PromptForTypeLibraries = False
 *   RetryOnReject = False
 *   IDispatchOnly = False
 *   GenBeanInfo = False
 *   LowerCaseMemberNames = True
 *   TreatInStarAsIn = False
 *   ArraysAsObjects = False
 *   OmitRestrictedMethods = False
 *   ClashPrefix = zz_
 *   ImplementConflictingInterfaces = False
 *   DontRenameSameMethods = False
 *   RenameConflictingInterfaceMethods = False
 *   ReuseMethods = False
 *
 * Command Line Only Options:
 *   MakeClsidsPublic = False
 *   DontOverwrite = False
 */
public class _SessionProxy extends com.linar.jintegra.Dispatch implements com.intrinsyc.cdo._Session, java.io.Serializable {

  protected String getJintegraVersion() { return "2.8"; }

  static { com.intrinsyc.cdo.JIntegraInit.init(); }

  public static final Class targetClass = _Session.class;

  public _SessionProxy(String CLSID, String host, AuthInfo authInfo) throws java.net.UnknownHostException, java.io.IOException{
    super(CLSID, _Session.IID, host, authInfo);
  }

  /** For internal use only */
  public _SessionProxy() {}

  public _SessionProxy(Object obj) throws java.io.IOException {
    super(obj, _Session.IID);
  }

  protected _SessionProxy(Object obj, String iid) throws java.io.IOException {
    super(obj, iid);
  }

  protected _SessionProxy(String CLSID, String iid, String host, AuthInfo authInfo) throws java.io.IOException {
    super(CLSID, iid, host, authInfo);
  }

  public void addListener(String iidStr, Object theListener, Object theSource) throws java.io.IOException {
    super.addListener(iidStr, theListener, theSource);
  }

  public void removeListener(String iidStr, Object theListener) throws java.io.IOException {
    super.removeListener(iidStr, theListener);
  }

  /**
   * getPropertyByName. Get the value of a property dynamically at run-time, based on its name
   *
   * @return    The value of the property.
   * @param     name The name of the property to get.
   * @exception java.lang.NoSuchFieldException If the property does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPropertyByName(String name) throws NoSuchFieldException, java.io.IOException, com.linar.jintegra.AutomationException {
    com.linar.jintegra.Variant parameters[] = {};
    return super.invoke(name, super.getDispatchIdOfName(name), 2, parameters).getVARIANT();
  }

  /**
   * getPropertyByName. Get the value of a property dynamically at run-time, based on its name and a parameter value
   *
   * @return    The value of the property.
   * @param     name The name of the property to get.
   * @param     rhs Parameter used when getting the property.
   * @exception java.lang.NoSuchFieldException If the property does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getPropertyByName(String name, Object rhs) throws NoSuchFieldException, java.io.IOException, com.linar.jintegra.AutomationException {
    com.linar.jintegra.Variant parameters[] = {rhs == null ? new Variant("rhs", 10, 0x80020004L) : new Variant("rhs", 12, rhs)};
    return super.invoke(name, super.getDispatchIdOfName(name), 2, parameters).getVARIANT();
  }

  /**
   * invokeMethodByName. Invoke a method dynamically at run-time
   *
   * @return    The value returned by the method (null if none).
   * @param     name The name of the method to be invoked
   * @param     parameters One element for each parameter.  Use primitive type wrappers
   *            to pass primitive types (eg Integer to pass an int).
   * @exception java.lang.NoSuchMethodException If the method does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object invokeMethodByName(String name, Object[] parameters) throws NoSuchMethodException, java.io.IOException, com.linar.jintegra.AutomationException {
    com.linar.jintegra.Variant variantParameters[] = new com.linar.jintegra.Variant[parameters.length];
    for(int i = 0; i < parameters.length; i++) {
      variantParameters[i] = parameters[i] == null ? new Variant("p" + i, 10, 0x80020004L) :
	                                                   new Variant("p" + i, 12, parameters[i]);
    }
    try {
      return super.invoke(name, super.getDispatchIdOfName(name), 1, variantParameters).getVARIANT();
    } catch(NoSuchFieldException nsfe) {
      throw new NoSuchMethodException("There is no method called " + name);
    }
  }

  /**
   * invokeMethodByName. Invoke a method dynamically at run-time
   *
   * @return    The value returned by the method (null if none).
   * @param     name The name of the method to be invoked
   * @exception java.lang.NoSuchMethodException If the method does not exit.
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object invokeMethodByName(String name) throws NoSuchMethodException, java.io.IOException, com.linar.jintegra.AutomationException {
      return invokeMethodByName(name, new Object[]{});
  }

  /**
   * getApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getApplication  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getApplication", 20, 2, parameters).getVARIANT();
  }

  /**
   * setApplication. The Application property returns the name of the active application, namely the CDO Library, 'Collaboration Data Objects'.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setApplication  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setApplication", 20, 4, parameters);
    return;
  }

  /**
   * getParent. The Parent property returns the parent of the object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getParent  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getParent", 25, 2, parameters).getVARIANT();
  }

  /**
   * setParent. The Parent property returns the parent of the object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setParent  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setParent", 25, 4, parameters);
    return;
  }

  /**
   * getSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getSession  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getSession", 34, 2, parameters).getVARIANT();
  }

  /**
   * setSession. The Session property returns the top-level Session object associated with the specified CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setSession  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setSession", 34, 4, parameters);
    return;
  }

  /**
   * zz_getClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object zz_getClass  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("zz_getClass", 6, 2, parameters).getVARIANT();
  }

  /**
   * setClass. The Class property returns a numeric constant that identifies the CDO Library object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setClass  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setClass", 6, 4, parameters);
    return;
  }

  /**
   * getMAPIOBJECT. 
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMAPIOBJECT  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getMAPIOBJECT", 49, 2, parameters).getVARIANT();
  }

  /**
   * setMAPIOBJECT. 
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setMAPIOBJECT  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setMAPIOBJECT", 49, 4, parameters);
    return;
  }

  /**
   * getVersion. The Version property returns the version number of the CDO Library.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getVersion  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getVersion", 44, 2, parameters).getVARIANT();
  }

  /**
   * setVersion. The Version property returns the version number of the CDO Library.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setVersion  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setVersion", 44, 4, parameters);
    return;
  }

  /**
   * getOperatingSystem. The OperatingSystem property returns the name and version number of the current operating system.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOperatingSystem  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getOperatingSystem", 24, 2, parameters).getVARIANT();
  }

  /**
   * setOperatingSystem. The OperatingSystem property returns the name and version number of the current operating system.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOperatingSystem  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setOperatingSystem", 24, 4, parameters);
    return;
  }

  /**
   * getName. The Name property returns the display name of the profile logged on to this session.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getName  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getName", 23, 2, parameters).getVARIANT();
  }

  /**
   * setName. The Name property returns the display name of the profile logged on to this session.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setName  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setName", 23, 4, parameters);
    return;
  }

  /**
   * getCurrentUser. The CurrentUser property returns the active user as an AddressEntry object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getCurrentUser  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getCurrentUser", 1, 2, parameters).getVARIANT();
  }

  /**
   * setCurrentUser. The CurrentUser property returns the active user as an AddressEntry object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setCurrentUser  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setCurrentUser", 1, 4, parameters);
    return;
  }

  /**
   * getInbox. The Inbox property returns a Folder object representing the current user's Inbox folder.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getInbox  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getInbox", 15, 2, parameters).getVARIANT();
  }

  /**
   * setInbox. The Inbox property returns a Folder object representing the current user's Inbox folder.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setInbox  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setInbox", 15, 4, parameters);
    return;
  }

  /**
   * getOutbox. The Outbox property returns a Folder object representing the current user's Outbox folder.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOutbox  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getOutbox", 16, 2, parameters).getVARIANT();
  }

  /**
   * setOutbox. The Outbox property returns a Folder object representing the current user's Outbox folder.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOutbox  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setOutbox", 16, 4, parameters);
    return;
  }

  /**
   * getInfoStores. The InfoStores property returns an InfoStores collection available to this session.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getInfoStores  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getInfoStores", 57, 2, parameters).getVARIANT();
  }

  /**
   * setInfoStores. The InfoStores property returns an InfoStores collection available to this session.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setInfoStores  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setInfoStores", 57, 4, parameters);
    return;
  }

  /**
   * getAddressLists. The AddressLists property returns a single AddressList object or an AddressLists collection object.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAddressLists  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getAddressLists", 4, 2, parameters).getVARIANT();
  }

  /**
   * setAddressLists. The AddressLists property returns a single AddressList object or an AddressLists collection object.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setAddressLists  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setAddressLists", 4, 4, parameters);
    return;
  }

  /**
   * getOutOfOffice. The OutofOffice property indicates whether the user is currently considered out of the office.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOutOfOffice  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getOutOfOffice", 82, 2, parameters).getVARIANT();
  }

  /**
   * setOutOfOffice. The OutofOffice property indicates whether the user is currently considered out of the office.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOutOfOffice  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setOutOfOffice", 82, 4, parameters);
    return;
  }

  /**
   * getOutOfOfficeText. The OutOfOfficeText property is the text of the message others receive if they send mail to this user while the user is out of the office.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOutOfOfficeText  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("getOutOfOfficeText", 83, 2, parameters).getVARIANT();
  }

  /**
   * setOutOfOfficeText. The OutOfOfficeText property is the text of the message others receive if they send mail to this user while the user is out of the office.
   *
   * @param     rhs A Variant)
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public void setOutOfOfficeText  (
              Object rhs) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {rhs == null ? new Variant("rhs", 0, 0x80020004L) : new Variant("rhs", 12, rhs),};
    invoke("setOutOfOfficeText", 83, 4, parameters);
    return;
  }

  /**
   * logon. The Logon method logs on to the messaging system.
   *
   * @param     profileName A Variant (in, optional, pass null if not required)
   * @param     profilePassword A Variant (in, optional, pass null if not required)
   * @param     showDialog A Variant (in, optional, pass null if not required)
   * @param     newSession A Variant (in, optional, pass null if not required)
   * @param     parentWindow A Variant (in, optional, pass null if not required)
   * @param     noMail A Variant (in, optional, pass null if not required)
   * @param     profileInfo A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object logon  (
              Object profileName,
              Object profilePassword,
              Object showDialog,
              Object newSession,
              Object parentWindow,
              Object noMail,
              Object profileInfo) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {profileName == null ? new Variant("profileName", 10, 0x80020004L) : new Variant("profileName", 12, profileName),
                                         profilePassword == null ? new Variant("profilePassword", 10, 0x80020004L) : new Variant("profilePassword", 12, profilePassword),
                                         showDialog == null ? new Variant("showDialog", 10, 0x80020004L) : new Variant("showDialog", 12, showDialog),
                                         newSession == null ? new Variant("newSession", 10, 0x80020004L) : new Variant("newSession", 12, newSession),
                                         parentWindow == null ? new Variant("parentWindow", 10, 0x80020004L) : new Variant("parentWindow", 12, parentWindow),
                                         noMail == null ? new Variant("noMail", 10, 0x80020004L) : new Variant("noMail", 12, noMail),
                                         profileInfo == null ? new Variant("profileInfo", 10, 0x80020004L) : new Variant("profileInfo", 12, profileInfo),};
    return invoke("logon", 119, 1, parameters).getVARIANT();
  }

  /**
   * logoff. The Logoff method logs off from the messaging system.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object logoff  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("logoff", 118, 1, parameters).getVARIANT();
  }

  /**
   * getInfoStore. The GetInfoStore method returns an InfoStore object that can be used to navigate through both public folders and the user's personal folders.
   *
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getInfoStore  (
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {storeID == null ? new Variant("storeID", 10, 0x80020004L) : new Variant("storeID", 12, storeID),};
    return invoke("getInfoStore", 122, 1, parameters).getVARIANT();
  }

  /**
   * getFolder. The GetFolder method returns a Folder object from a message store.
   *
   * @param     folderID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getFolder  (
              Object folderID,
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {folderID == null ? new Variant("folderID", 0, 0x80020004L) : new Variant("folderID", 12, folderID),
                                         storeID == null ? new Variant("storeID", 10, 0x80020004L) : new Variant("storeID", 12, storeID),};
    return invoke("getFolder", 116, 1, parameters).getVARIANT();
  }

  /**
   * getMessage. The GetMessage method returns a Message object from a message store.
   *
   * @param     messageID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getMessage  (
              Object messageID,
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {messageID == null ? new Variant("messageID", 0, 0x80020004L) : new Variant("messageID", 12, messageID),
                                         storeID == null ? new Variant("storeID", 10, 0x80020004L) : new Variant("storeID", 12, storeID),};
    return invoke("getMessage", 117, 1, parameters).getVARIANT();
  }

  /**
   * getArticle. The GetArticle method returns a Message object from a message store based on its article ID.
   *
   * @param     articleID A Variant (in)
   * @param     folderID A Variant (in)
   * @param     storeID A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getArticle  (
              Object articleID,
              Object folderID,
              Object storeID) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {articleID == null ? new Variant("articleID", 0, 0x80020004L) : new Variant("articleID", 12, articleID),
                                         folderID == null ? new Variant("folderID", 0, 0x80020004L) : new Variant("folderID", 12, folderID),
                                         storeID == null ? new Variant("storeID", 10, 0x80020004L) : new Variant("storeID", 12, storeID),};
    return invoke("getArticle", 158, 1, parameters).getVARIANT();
  }

  /**
   * getAddressEntry. The GetAddressEntry method returns an AddressEntry object.
   *
   * @param     entryID A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAddressEntry  (
              Object entryID) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {entryID == null ? new Variant("entryID", 0, 0x80020004L) : new Variant("entryID", 12, entryID),};
    return invoke("getAddressEntry", 114, 1, parameters).getVARIANT();
  }

  /**
   * addressBook. The AddressBook method displays a modal dialog box that allows the user to select entries from the address book. The selections are returned in a Recipients collection object.
   *
   * @param     recipients A Variant (in, optional, pass null if not required)
   * @param     title A Variant (in, optional, pass null if not required)
   * @param     oneAddress A Variant (in, optional, pass null if not required)
   * @param     forceResolution A Variant (in, optional, pass null if not required)
   * @param     recipLists A Variant (in, optional, pass null if not required)
   * @param     toLabel A Variant (in, optional, pass null if not required)
   * @param     ccLabel A Variant (in, optional, pass null if not required)
   * @param     bccLabel A Variant (in, optional, pass null if not required)
   * @param     parentWindow A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object addressBook  (
              Object recipients,
              Object title,
              Object oneAddress,
              Object forceResolution,
              Object recipLists,
              Object toLabel,
              Object ccLabel,
              Object bccLabel,
              Object parentWindow) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {recipients == null ? new Variant("recipients", 10, 0x80020004L) : new Variant("recipients", 12, recipients),
                                         title == null ? new Variant("title", 10, 0x80020004L) : new Variant("title", 12, title),
                                         oneAddress == null ? new Variant("oneAddress", 10, 0x80020004L) : new Variant("oneAddress", 12, oneAddress),
                                         forceResolution == null ? new Variant("forceResolution", 10, 0x80020004L) : new Variant("forceResolution", 12, forceResolution),
                                         recipLists == null ? new Variant("recipLists", 10, 0x80020004L) : new Variant("recipLists", 12, recipLists),
                                         toLabel == null ? new Variant("toLabel", 10, 0x80020004L) : new Variant("toLabel", 12, toLabel),
                                         ccLabel == null ? new Variant("ccLabel", 10, 0x80020004L) : new Variant("ccLabel", 12, ccLabel),
                                         bccLabel == null ? new Variant("bccLabel", 10, 0x80020004L) : new Variant("bccLabel", 12, bccLabel),
                                         parentWindow == null ? new Variant("parentWindow", 10, 0x80020004L) : new Variant("parentWindow", 12, parentWindow),};
    return invoke("addressBook", 101, 1, parameters).getVARIANT();
  }

  /**
   * deliverNow. The DeliverNow method requests immediate delivery of all undelivered messages submitted in the current session.
   *
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object deliverNow  () throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {};
    return invoke("deliverNow", 108, 1, parameters).getVARIANT();
  }

  /**
   * compareIDs. The CompareIDs method determines whether two CDO Library objects are the same object.
   *
   * @param     iD1 A Variant (in)
   * @param     iD2 A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object compareIDs  (
              Object iD1,
              Object iD2) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {iD1 == null ? new Variant("iD1", 0, 0x80020004L) : new Variant("iD1", 12, iD1),
                                         iD2 == null ? new Variant("iD2", 0, 0x80020004L) : new Variant("iD2", 12, iD2),};
    return invoke("compareIDs", 137, 1, parameters).getVARIANT();
  }

  /**
   * createConversationIndex. The CreateConversationIndex method creates a new conversation index or a child conversation index based on a parent conversation index.
   *
   * @param     parentIndex A Variant (in, optional, pass null if not required)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object createConversationIndex  (
              Object parentIndex) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {parentIndex == null ? new Variant("parentIndex", 10, 0x80020004L) : new Variant("parentIndex", 12, parentIndex),};
    return invoke("createConversationIndex", 146, 1, parameters).getVARIANT();
  }

  /**
   * setLocaleIDs. The SetLocaleIDs method sets the Locale, Sort Locale, and Codepage IDs for the current session.
   *
   * @param     localeID A Variant (in)
   * @param     codePageID A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object setLocaleIDs  (
              Object localeID,
              Object codePageID) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {localeID == null ? new Variant("localeID", 0, 0x80020004L) : new Variant("localeID", 12, localeID),
                                         codePageID == null ? new Variant("codePageID", 0, 0x80020004L) : new Variant("codePageID", 12, codePageID),};
    return invoke("setLocaleIDs", 145, 1, parameters).getVARIANT();
  }

  /**
   * getDefaultFolder. The GetDefaultFolder method returns the default folder of the specified type.
   *
   * @param     objectType A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getDefaultFolder  (
              Object objectType) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {objectType == null ? new Variant("objectType", 0, 0x80020004L) : new Variant("objectType", 12, objectType),};
    return invoke("getDefaultFolder", 153, 1, parameters).getVARIANT();
  }

  /**
   * getAddressList. The GetAddressList method returns the default address list of the specified type.
   *
   * @param     objectType A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getAddressList  (
              Object objectType) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {objectType == null ? new Variant("objectType", 0, 0x80020004L) : new Variant("objectType", 12, objectType),};
    return invoke("getAddressList", 155, 1, parameters).getVARIANT();
  }

  /**
   * getOption. The GetOption method returns a user preference.
   *
   * @param     optType A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object getOption  (
              Object optType) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {optType == null ? new Variant("optType", 0, 0x80020004L) : new Variant("optType", 12, optType),};
    return invoke("getOption", 156, 1, parameters).getVARIANT();
  }

  /**
   * setOption. The SetOption method sets a user preference.
   *
   * @param     optType A Variant (in)
   * @param     optValue A Variant (in)
   * @return    A Variant
   * @exception java.io.IOException If there are communications problems.
   * @exception com.linar.jintegra.AutomationException If the remote server throws an exception.
   */
  public Object setOption  (
              Object optType,
              Object optValue) throws java.io.IOException, com.linar.jintegra.AutomationException{
    com.linar.jintegra.Variant[] parameters = {optType == null ? new Variant("optType", 0, 0x80020004L) : new Variant("optType", 12, optType),
                                         optValue == null ? new Variant("optValue", 0, 0x80020004L) : new Variant("optValue", 12, optValue),};
    return invoke("setOption", 157, 1, parameters).getVARIANT();
  }

  /** Dummy reference from interface to proxy to make sure proxy gets compiled */
  static final int xxDummy = 0;

  static {
    com.linar.jintegra.InterfaceDesc.add("3fa7dea8-6438-101b-acc1-00aa00423326", com.intrinsyc.cdo._SessionProxy.class, null, 0, null );
  }
}
